// Code generated by go-swagger; DO NOT EDIT.

package artifact

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCopyArtifactParams creates a new CopyArtifactParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCopyArtifactParams() *CopyArtifactParams {
	return &CopyArtifactParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCopyArtifactParamsWithTimeout creates a new CopyArtifactParams object
// with the ability to set a timeout on a request.
func NewCopyArtifactParamsWithTimeout(timeout time.Duration) *CopyArtifactParams {
	return &CopyArtifactParams{
		timeout: timeout,
	}
}

// NewCopyArtifactParamsWithContext creates a new CopyArtifactParams object
// with the ability to set a context for a request.
func NewCopyArtifactParamsWithContext(ctx context.Context) *CopyArtifactParams {
	return &CopyArtifactParams{
		Context: ctx,
	}
}

// NewCopyArtifactParamsWithHTTPClient creates a new CopyArtifactParams object
// with the ability to set a custom HTTPClient for a request.
func NewCopyArtifactParamsWithHTTPClient(client *http.Client) *CopyArtifactParams {
	return &CopyArtifactParams{
		HTTPClient: client,
	}
}

/*
CopyArtifactParams contains all the parameters to send to the API endpoint

	for the copy artifact operation.

	Typically these are written to a http.Request.
*/
type CopyArtifactParams struct {

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* From.

	   The artifact from which the new artifact is copied from, the format should be "project/repository:tag" or "project/repository@digest".
	*/
	From string

	/* ProjectName.

	   The name of the project
	*/
	ProjectName string

	/* RepositoryName.

	   The name of the repository. If it contains slash, encode it twice over with URL encoding. e.g. a/b -> a%2Fb -> a%252Fb
	*/
	RepositoryName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the copy artifact params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CopyArtifactParams) WithDefaults() *CopyArtifactParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the copy artifact params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CopyArtifactParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the copy artifact params
func (o *CopyArtifactParams) WithTimeout(timeout time.Duration) *CopyArtifactParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the copy artifact params
func (o *CopyArtifactParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the copy artifact params
func (o *CopyArtifactParams) WithContext(ctx context.Context) *CopyArtifactParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the copy artifact params
func (o *CopyArtifactParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the copy artifact params
func (o *CopyArtifactParams) WithHTTPClient(client *http.Client) *CopyArtifactParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the copy artifact params
func (o *CopyArtifactParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXRequestID adds the xRequestID to the copy artifact params
func (o *CopyArtifactParams) WithXRequestID(xRequestID *string) *CopyArtifactParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the copy artifact params
func (o *CopyArtifactParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithFrom adds the from to the copy artifact params
func (o *CopyArtifactParams) WithFrom(from string) *CopyArtifactParams {
	o.SetFrom(from)
	return o
}

// SetFrom adds the from to the copy artifact params
func (o *CopyArtifactParams) SetFrom(from string) {
	o.From = from
}

// WithProjectName adds the projectName to the copy artifact params
func (o *CopyArtifactParams) WithProjectName(projectName string) *CopyArtifactParams {
	o.SetProjectName(projectName)
	return o
}

// SetProjectName adds the projectName to the copy artifact params
func (o *CopyArtifactParams) SetProjectName(projectName string) {
	o.ProjectName = projectName
}

// WithRepositoryName adds the repositoryName to the copy artifact params
func (o *CopyArtifactParams) WithRepositoryName(repositoryName string) *CopyArtifactParams {
	o.SetRepositoryName(repositoryName)
	return o
}

// SetRepositoryName adds the repositoryName to the copy artifact params
func (o *CopyArtifactParams) SetRepositoryName(repositoryName string) {
	o.RepositoryName = repositoryName
}

// WriteToRequest writes these params to a swagger request
func (o *CopyArtifactParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// query param from
	qrFrom := o.From
	qFrom := qrFrom
	if qFrom != "" {

		if err := r.SetQueryParam("from", qFrom); err != nil {
			return err
		}
	}

	// path param project_name
	if err := r.SetPathParam("project_name", o.ProjectName); err != nil {
		return err
	}

	// path param repository_name
	if err := r.SetPathParam("repository_name", o.RepositoryName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
