// Code generated by go-swagger; DO NOT EDIT.

package artifact

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// DeleteArtifactReader is a Reader for the DeleteArtifact structure.
type DeleteArtifactReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteArtifactReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteArtifactOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteArtifactUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteArtifactForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteArtifactNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteArtifactInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewDeleteArtifactOK creates a DeleteArtifactOK with default headers values
func NewDeleteArtifactOK() *DeleteArtifactOK {
	return &DeleteArtifactOK{}
}

/*
DeleteArtifactOK describes a response with status code 200, with default header values.

Success
*/
type DeleteArtifactOK struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string
}

// IsSuccess returns true when this delete artifact o k response has a 2xx status code
func (o *DeleteArtifactOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete artifact o k response has a 3xx status code
func (o *DeleteArtifactOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete artifact o k response has a 4xx status code
func (o *DeleteArtifactOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete artifact o k response has a 5xx status code
func (o *DeleteArtifactOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete artifact o k response a status code equal to that given
func (o *DeleteArtifactOK) IsCode(code int) bool {
	return code == 200
}

func (o *DeleteArtifactOK) Error() string {
	return fmt.Sprintf("[DELETE /projects/{project_name}/repositories/{repository_name}/artifacts/{reference}][%d] deleteArtifactOK ", 200)
}

func (o *DeleteArtifactOK) String() string {
	return fmt.Sprintf("[DELETE /projects/{project_name}/repositories/{repository_name}/artifacts/{reference}][%d] deleteArtifactOK ", 200)
}

func (o *DeleteArtifactOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	return nil
}

// NewDeleteArtifactUnauthorized creates a DeleteArtifactUnauthorized with default headers values
func NewDeleteArtifactUnauthorized() *DeleteArtifactUnauthorized {
	return &DeleteArtifactUnauthorized{}
}

/*
DeleteArtifactUnauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type DeleteArtifactUnauthorized struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this delete artifact unauthorized response has a 2xx status code
func (o *DeleteArtifactUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete artifact unauthorized response has a 3xx status code
func (o *DeleteArtifactUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete artifact unauthorized response has a 4xx status code
func (o *DeleteArtifactUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete artifact unauthorized response has a 5xx status code
func (o *DeleteArtifactUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this delete artifact unauthorized response a status code equal to that given
func (o *DeleteArtifactUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *DeleteArtifactUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /projects/{project_name}/repositories/{repository_name}/artifacts/{reference}][%d] deleteArtifactUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteArtifactUnauthorized) String() string {
	return fmt.Sprintf("[DELETE /projects/{project_name}/repositories/{repository_name}/artifacts/{reference}][%d] deleteArtifactUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteArtifactUnauthorized) GetPayload() *models.Errors {
	return o.Payload
}

func (o *DeleteArtifactUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteArtifactForbidden creates a DeleteArtifactForbidden with default headers values
func NewDeleteArtifactForbidden() *DeleteArtifactForbidden {
	return &DeleteArtifactForbidden{}
}

/*
DeleteArtifactForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type DeleteArtifactForbidden struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this delete artifact forbidden response has a 2xx status code
func (o *DeleteArtifactForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete artifact forbidden response has a 3xx status code
func (o *DeleteArtifactForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete artifact forbidden response has a 4xx status code
func (o *DeleteArtifactForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete artifact forbidden response has a 5xx status code
func (o *DeleteArtifactForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this delete artifact forbidden response a status code equal to that given
func (o *DeleteArtifactForbidden) IsCode(code int) bool {
	return code == 403
}

func (o *DeleteArtifactForbidden) Error() string {
	return fmt.Sprintf("[DELETE /projects/{project_name}/repositories/{repository_name}/artifacts/{reference}][%d] deleteArtifactForbidden  %+v", 403, o.Payload)
}

func (o *DeleteArtifactForbidden) String() string {
	return fmt.Sprintf("[DELETE /projects/{project_name}/repositories/{repository_name}/artifacts/{reference}][%d] deleteArtifactForbidden  %+v", 403, o.Payload)
}

func (o *DeleteArtifactForbidden) GetPayload() *models.Errors {
	return o.Payload
}

func (o *DeleteArtifactForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteArtifactNotFound creates a DeleteArtifactNotFound with default headers values
func NewDeleteArtifactNotFound() *DeleteArtifactNotFound {
	return &DeleteArtifactNotFound{}
}

/*
DeleteArtifactNotFound describes a response with status code 404, with default header values.

Not found
*/
type DeleteArtifactNotFound struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this delete artifact not found response has a 2xx status code
func (o *DeleteArtifactNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete artifact not found response has a 3xx status code
func (o *DeleteArtifactNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete artifact not found response has a 4xx status code
func (o *DeleteArtifactNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete artifact not found response has a 5xx status code
func (o *DeleteArtifactNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this delete artifact not found response a status code equal to that given
func (o *DeleteArtifactNotFound) IsCode(code int) bool {
	return code == 404
}

func (o *DeleteArtifactNotFound) Error() string {
	return fmt.Sprintf("[DELETE /projects/{project_name}/repositories/{repository_name}/artifacts/{reference}][%d] deleteArtifactNotFound  %+v", 404, o.Payload)
}

func (o *DeleteArtifactNotFound) String() string {
	return fmt.Sprintf("[DELETE /projects/{project_name}/repositories/{repository_name}/artifacts/{reference}][%d] deleteArtifactNotFound  %+v", 404, o.Payload)
}

func (o *DeleteArtifactNotFound) GetPayload() *models.Errors {
	return o.Payload
}

func (o *DeleteArtifactNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteArtifactInternalServerError creates a DeleteArtifactInternalServerError with default headers values
func NewDeleteArtifactInternalServerError() *DeleteArtifactInternalServerError {
	return &DeleteArtifactInternalServerError{}
}

/*
DeleteArtifactInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type DeleteArtifactInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this delete artifact internal server error response has a 2xx status code
func (o *DeleteArtifactInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete artifact internal server error response has a 3xx status code
func (o *DeleteArtifactInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete artifact internal server error response has a 4xx status code
func (o *DeleteArtifactInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete artifact internal server error response has a 5xx status code
func (o *DeleteArtifactInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this delete artifact internal server error response a status code equal to that given
func (o *DeleteArtifactInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *DeleteArtifactInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /projects/{project_name}/repositories/{repository_name}/artifacts/{reference}][%d] deleteArtifactInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteArtifactInternalServerError) String() string {
	return fmt.Sprintf("[DELETE /projects/{project_name}/repositories/{repository_name}/artifacts/{reference}][%d] deleteArtifactInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteArtifactInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *DeleteArtifactInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
