// Code generated by go-swagger; DO NOT EDIT.

package artifact

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRemoveLabelParams creates a new RemoveLabelParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRemoveLabelParams() *RemoveLabelParams {
	return &RemoveLabelParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRemoveLabelParamsWithTimeout creates a new RemoveLabelParams object
// with the ability to set a timeout on a request.
func NewRemoveLabelParamsWithTimeout(timeout time.Duration) *RemoveLabelParams {
	return &RemoveLabelParams{
		timeout: timeout,
	}
}

// NewRemoveLabelParamsWithContext creates a new RemoveLabelParams object
// with the ability to set a context for a request.
func NewRemoveLabelParamsWithContext(ctx context.Context) *RemoveLabelParams {
	return &RemoveLabelParams{
		Context: ctx,
	}
}

// NewRemoveLabelParamsWithHTTPClient creates a new RemoveLabelParams object
// with the ability to set a custom HTTPClient for a request.
func NewRemoveLabelParamsWithHTTPClient(client *http.Client) *RemoveLabelParams {
	return &RemoveLabelParams{
		HTTPClient: client,
	}
}

/*
RemoveLabelParams contains all the parameters to send to the API endpoint

	for the remove label operation.

	Typically these are written to a http.Request.
*/
type RemoveLabelParams struct {

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* LabelID.

	   The ID of the label that removed from the artifact.

	   Format: int64
	*/
	LabelID int64

	/* ProjectName.

	   The name of the project
	*/
	ProjectName string

	/* Reference.

	   The reference of the artifact, can be digest or tag
	*/
	Reference string

	/* RepositoryName.

	   The name of the repository. If it contains slash, encode it twice over with URL encoding. e.g. a/b -> a%2Fb -> a%252Fb
	*/
	RepositoryName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the remove label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RemoveLabelParams) WithDefaults() *RemoveLabelParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the remove label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RemoveLabelParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the remove label params
func (o *RemoveLabelParams) WithTimeout(timeout time.Duration) *RemoveLabelParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the remove label params
func (o *RemoveLabelParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the remove label params
func (o *RemoveLabelParams) WithContext(ctx context.Context) *RemoveLabelParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the remove label params
func (o *RemoveLabelParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the remove label params
func (o *RemoveLabelParams) WithHTTPClient(client *http.Client) *RemoveLabelParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the remove label params
func (o *RemoveLabelParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXRequestID adds the xRequestID to the remove label params
func (o *RemoveLabelParams) WithXRequestID(xRequestID *string) *RemoveLabelParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the remove label params
func (o *RemoveLabelParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithLabelID adds the labelID to the remove label params
func (o *RemoveLabelParams) WithLabelID(labelID int64) *RemoveLabelParams {
	o.SetLabelID(labelID)
	return o
}

// SetLabelID adds the labelId to the remove label params
func (o *RemoveLabelParams) SetLabelID(labelID int64) {
	o.LabelID = labelID
}

// WithProjectName adds the projectName to the remove label params
func (o *RemoveLabelParams) WithProjectName(projectName string) *RemoveLabelParams {
	o.SetProjectName(projectName)
	return o
}

// SetProjectName adds the projectName to the remove label params
func (o *RemoveLabelParams) SetProjectName(projectName string) {
	o.ProjectName = projectName
}

// WithReference adds the reference to the remove label params
func (o *RemoveLabelParams) WithReference(reference string) *RemoveLabelParams {
	o.SetReference(reference)
	return o
}

// SetReference adds the reference to the remove label params
func (o *RemoveLabelParams) SetReference(reference string) {
	o.Reference = reference
}

// WithRepositoryName adds the repositoryName to the remove label params
func (o *RemoveLabelParams) WithRepositoryName(repositoryName string) *RemoveLabelParams {
	o.SetRepositoryName(repositoryName)
	return o
}

// SetRepositoryName adds the repositoryName to the remove label params
func (o *RemoveLabelParams) SetRepositoryName(repositoryName string) {
	o.RepositoryName = repositoryName
}

// WriteToRequest writes these params to a swagger request
func (o *RemoveLabelParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param label_id
	if err := r.SetPathParam("label_id", swag.FormatInt64(o.LabelID)); err != nil {
		return err
	}

	// path param project_name
	if err := r.SetPathParam("project_name", o.ProjectName); err != nil {
		return err
	}

	// path param reference
	if err := r.SetPathParam("reference", o.Reference); err != nil {
		return err
	}

	// path param repository_name
	if err := r.SetPathParam("repository_name", o.RepositoryName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
