// Code generated by go-swagger; DO NOT EDIT.

package configure

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

//go:generate mockery -name API -inpkg

// API is the interface of the configure client
type API interface {
	/*
	   GetConfigurations gets system configurations

	   This endpoint is for retrieving system configurations that only provides for admin user.
	*/
	GetConfigurations(ctx context.Context, params *GetConfigurationsParams) (*GetConfigurationsOK, error)
	/*
	   GetInternalconfig gets internal configurations

	   This endpoint is for retrieving system configurations that only provides for internal api call.
	*/
	GetInternalconfig(ctx context.Context, params *GetInternalconfigParams) (*GetInternalconfigOK, error)
	/*
	   UpdateConfigurations modifies system configurations

	   This endpoint is for modifying system configurations that only provides for admin user.
	*/
	UpdateConfigurations(ctx context.Context, params *UpdateConfigurationsParams) (*UpdateConfigurationsOK, error)
}

// New creates a new configure API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry, authInfo runtime.ClientAuthInfoWriter) *Client {
	return &Client{
		transport: transport,
		formats:   formats,
		authInfo:  authInfo,
	}
}

/*
Client for configure API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
	authInfo  runtime.ClientAuthInfoWriter
}

/*
GetConfigurations gets system configurations

This endpoint is for retrieving system configurations that only provides for admin user.
*/
func (a *Client) GetConfigurations(ctx context.Context, params *GetConfigurationsParams) (*GetConfigurationsOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getConfigurations",
		Method:             "GET",
		PathPattern:        "/configurations",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetConfigurationsReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetConfigurationsOK), nil

}

/*
GetInternalconfig gets internal configurations

This endpoint is for retrieving system configurations that only provides for internal api call.
*/
func (a *Client) GetInternalconfig(ctx context.Context, params *GetInternalconfigParams) (*GetInternalconfigOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getInternalconfig",
		Method:             "GET",
		PathPattern:        "/internalconfig",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetInternalconfigReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetInternalconfigOK), nil

}

/*
UpdateConfigurations modifies system configurations

This endpoint is for modifying system configurations that only provides for admin user.
*/
func (a *Client) UpdateConfigurations(ctx context.Context, params *UpdateConfigurationsParams) (*UpdateConfigurationsOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "updateConfigurations",
		Method:             "PUT",
		PathPattern:        "/configurations",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &UpdateConfigurationsReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*UpdateConfigurationsOK), nil

}
