// Code generated by go-swagger; DO NOT EDIT.

package gc

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// CreateGCScheduleReader is a Reader for the CreateGCSchedule structure.
type CreateGCScheduleReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateGCScheduleReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewCreateGCScheduleCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewCreateGCScheduleBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewCreateGCScheduleUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewCreateGCScheduleForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 409:
		result := NewCreateGCScheduleConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewCreateGCScheduleInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewCreateGCScheduleCreated creates a CreateGCScheduleCreated with default headers values
func NewCreateGCScheduleCreated() *CreateGCScheduleCreated {
	return &CreateGCScheduleCreated{}
}

/*
CreateGCScheduleCreated describes a response with status code 201, with default header values.

Created
*/
type CreateGCScheduleCreated struct {

	/* The location of the resource
	 */
	Location string

	/* The ID of the corresponding request for the response
	 */
	XRequestID string
}

// IsSuccess returns true when this create Gc schedule created response has a 2xx status code
func (o *CreateGCScheduleCreated) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this create Gc schedule created response has a 3xx status code
func (o *CreateGCScheduleCreated) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create Gc schedule created response has a 4xx status code
func (o *CreateGCScheduleCreated) IsClientError() bool {
	return false
}

// IsServerError returns true when this create Gc schedule created response has a 5xx status code
func (o *CreateGCScheduleCreated) IsServerError() bool {
	return false
}

// IsCode returns true when this create Gc schedule created response a status code equal to that given
func (o *CreateGCScheduleCreated) IsCode(code int) bool {
	return code == 201
}

func (o *CreateGCScheduleCreated) Error() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleCreated ", 201)
}

func (o *CreateGCScheduleCreated) String() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleCreated ", 201)
}

func (o *CreateGCScheduleCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Location
	hdrLocation := response.GetHeader("Location")

	if hdrLocation != "" {
		o.Location = hdrLocation
	}

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	return nil
}

// NewCreateGCScheduleBadRequest creates a CreateGCScheduleBadRequest with default headers values
func NewCreateGCScheduleBadRequest() *CreateGCScheduleBadRequest {
	return &CreateGCScheduleBadRequest{}
}

/*
CreateGCScheduleBadRequest describes a response with status code 400, with default header values.

Bad request
*/
type CreateGCScheduleBadRequest struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create Gc schedule bad request response has a 2xx status code
func (o *CreateGCScheduleBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create Gc schedule bad request response has a 3xx status code
func (o *CreateGCScheduleBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create Gc schedule bad request response has a 4xx status code
func (o *CreateGCScheduleBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this create Gc schedule bad request response has a 5xx status code
func (o *CreateGCScheduleBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this create Gc schedule bad request response a status code equal to that given
func (o *CreateGCScheduleBadRequest) IsCode(code int) bool {
	return code == 400
}

func (o *CreateGCScheduleBadRequest) Error() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleBadRequest  %+v", 400, o.Payload)
}

func (o *CreateGCScheduleBadRequest) String() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleBadRequest  %+v", 400, o.Payload)
}

func (o *CreateGCScheduleBadRequest) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateGCScheduleBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateGCScheduleUnauthorized creates a CreateGCScheduleUnauthorized with default headers values
func NewCreateGCScheduleUnauthorized() *CreateGCScheduleUnauthorized {
	return &CreateGCScheduleUnauthorized{}
}

/*
CreateGCScheduleUnauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type CreateGCScheduleUnauthorized struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create Gc schedule unauthorized response has a 2xx status code
func (o *CreateGCScheduleUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create Gc schedule unauthorized response has a 3xx status code
func (o *CreateGCScheduleUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create Gc schedule unauthorized response has a 4xx status code
func (o *CreateGCScheduleUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this create Gc schedule unauthorized response has a 5xx status code
func (o *CreateGCScheduleUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this create Gc schedule unauthorized response a status code equal to that given
func (o *CreateGCScheduleUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *CreateGCScheduleUnauthorized) Error() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleUnauthorized  %+v", 401, o.Payload)
}

func (o *CreateGCScheduleUnauthorized) String() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleUnauthorized  %+v", 401, o.Payload)
}

func (o *CreateGCScheduleUnauthorized) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateGCScheduleUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateGCScheduleForbidden creates a CreateGCScheduleForbidden with default headers values
func NewCreateGCScheduleForbidden() *CreateGCScheduleForbidden {
	return &CreateGCScheduleForbidden{}
}

/*
CreateGCScheduleForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type CreateGCScheduleForbidden struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create Gc schedule forbidden response has a 2xx status code
func (o *CreateGCScheduleForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create Gc schedule forbidden response has a 3xx status code
func (o *CreateGCScheduleForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create Gc schedule forbidden response has a 4xx status code
func (o *CreateGCScheduleForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this create Gc schedule forbidden response has a 5xx status code
func (o *CreateGCScheduleForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this create Gc schedule forbidden response a status code equal to that given
func (o *CreateGCScheduleForbidden) IsCode(code int) bool {
	return code == 403
}

func (o *CreateGCScheduleForbidden) Error() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleForbidden  %+v", 403, o.Payload)
}

func (o *CreateGCScheduleForbidden) String() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleForbidden  %+v", 403, o.Payload)
}

func (o *CreateGCScheduleForbidden) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateGCScheduleForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateGCScheduleConflict creates a CreateGCScheduleConflict with default headers values
func NewCreateGCScheduleConflict() *CreateGCScheduleConflict {
	return &CreateGCScheduleConflict{}
}

/*
CreateGCScheduleConflict describes a response with status code 409, with default header values.

Conflict
*/
type CreateGCScheduleConflict struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create Gc schedule conflict response has a 2xx status code
func (o *CreateGCScheduleConflict) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create Gc schedule conflict response has a 3xx status code
func (o *CreateGCScheduleConflict) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create Gc schedule conflict response has a 4xx status code
func (o *CreateGCScheduleConflict) IsClientError() bool {
	return true
}

// IsServerError returns true when this create Gc schedule conflict response has a 5xx status code
func (o *CreateGCScheduleConflict) IsServerError() bool {
	return false
}

// IsCode returns true when this create Gc schedule conflict response a status code equal to that given
func (o *CreateGCScheduleConflict) IsCode(code int) bool {
	return code == 409
}

func (o *CreateGCScheduleConflict) Error() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleConflict  %+v", 409, o.Payload)
}

func (o *CreateGCScheduleConflict) String() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleConflict  %+v", 409, o.Payload)
}

func (o *CreateGCScheduleConflict) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateGCScheduleConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateGCScheduleInternalServerError creates a CreateGCScheduleInternalServerError with default headers values
func NewCreateGCScheduleInternalServerError() *CreateGCScheduleInternalServerError {
	return &CreateGCScheduleInternalServerError{}
}

/*
CreateGCScheduleInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type CreateGCScheduleInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create Gc schedule internal server error response has a 2xx status code
func (o *CreateGCScheduleInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create Gc schedule internal server error response has a 3xx status code
func (o *CreateGCScheduleInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create Gc schedule internal server error response has a 4xx status code
func (o *CreateGCScheduleInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this create Gc schedule internal server error response has a 5xx status code
func (o *CreateGCScheduleInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this create Gc schedule internal server error response a status code equal to that given
func (o *CreateGCScheduleInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *CreateGCScheduleInternalServerError) Error() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateGCScheduleInternalServerError) String() string {
	return fmt.Sprintf("[POST /system/gc/schedule][%d] createGcScheduleInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateGCScheduleInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateGCScheduleInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
