// Code generated by go-swagger; DO NOT EDIT.

package gc

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewStopGCParams creates a new StopGCParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStopGCParams() *StopGCParams {
	return &StopGCParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStopGCParamsWithTimeout creates a new StopGCParams object
// with the ability to set a timeout on a request.
func NewStopGCParamsWithTimeout(timeout time.Duration) *StopGCParams {
	return &StopGCParams{
		timeout: timeout,
	}
}

// NewStopGCParamsWithContext creates a new StopGCParams object
// with the ability to set a context for a request.
func NewStopGCParamsWithContext(ctx context.Context) *StopGCParams {
	return &StopGCParams{
		Context: ctx,
	}
}

// NewStopGCParamsWithHTTPClient creates a new StopGCParams object
// with the ability to set a custom HTTPClient for a request.
func NewStopGCParamsWithHTTPClient(client *http.Client) *StopGCParams {
	return &StopGCParams{
		HTTPClient: client,
	}
}

/*
StopGCParams contains all the parameters to send to the API endpoint

	for the stop GC operation.

	Typically these are written to a http.Request.
*/
type StopGCParams struct {

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* GCID.

	   The ID of the gc log

	   Format: int64
	*/
	GCID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the stop GC params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StopGCParams) WithDefaults() *StopGCParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the stop GC params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StopGCParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the stop GC params
func (o *StopGCParams) WithTimeout(timeout time.Duration) *StopGCParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the stop GC params
func (o *StopGCParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the stop GC params
func (o *StopGCParams) WithContext(ctx context.Context) *StopGCParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the stop GC params
func (o *StopGCParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the stop GC params
func (o *StopGCParams) WithHTTPClient(client *http.Client) *StopGCParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the stop GC params
func (o *StopGCParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXRequestID adds the xRequestID to the stop GC params
func (o *StopGCParams) WithXRequestID(xRequestID *string) *StopGCParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the stop GC params
func (o *StopGCParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithGCID adds the gCID to the stop GC params
func (o *StopGCParams) WithGCID(gCID int64) *StopGCParams {
	o.SetGCID(gCID)
	return o
}

// SetGCID adds the gcId to the stop GC params
func (o *StopGCParams) SetGCID(gCID int64) {
	o.GCID = gCID
}

// WriteToRequest writes these params to a swagger request
func (o *StopGCParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param gc_id
	if err := r.SetPathParam("gc_id", swag.FormatInt64(o.GCID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
