// Code generated by go-swagger; DO NOT EDIT.

package icon

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetIconParams creates a new GetIconParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetIconParams() *GetIconParams {
	return &GetIconParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetIconParamsWithTimeout creates a new GetIconParams object
// with the ability to set a timeout on a request.
func NewGetIconParamsWithTimeout(timeout time.Duration) *GetIconParams {
	return &GetIconParams{
		timeout: timeout,
	}
}

// NewGetIconParamsWithContext creates a new GetIconParams object
// with the ability to set a context for a request.
func NewGetIconParamsWithContext(ctx context.Context) *GetIconParams {
	return &GetIconParams{
		Context: ctx,
	}
}

// NewGetIconParamsWithHTTPClient creates a new GetIconParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetIconParamsWithHTTPClient(client *http.Client) *GetIconParams {
	return &GetIconParams{
		HTTPClient: client,
	}
}

/*
GetIconParams contains all the parameters to send to the API endpoint

	for the get icon operation.

	Typically these are written to a http.Request.
*/
type GetIconParams struct {

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* Digest.

	   The digest of the resource
	*/
	Digest string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get icon params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIconParams) WithDefaults() *GetIconParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get icon params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIconParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get icon params
func (o *GetIconParams) WithTimeout(timeout time.Duration) *GetIconParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get icon params
func (o *GetIconParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get icon params
func (o *GetIconParams) WithContext(ctx context.Context) *GetIconParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get icon params
func (o *GetIconParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get icon params
func (o *GetIconParams) WithHTTPClient(client *http.Client) *GetIconParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get icon params
func (o *GetIconParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXRequestID adds the xRequestID to the get icon params
func (o *GetIconParams) WithXRequestID(xRequestID *string) *GetIconParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the get icon params
func (o *GetIconParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithDigest adds the digest to the get icon params
func (o *GetIconParams) WithDigest(digest string) *GetIconParams {
	o.SetDigest(digest)
	return o
}

// SetDigest adds the digest to the get icon params
func (o *GetIconParams) SetDigest(digest string) {
	o.Digest = digest
}

// WriteToRequest writes these params to a swagger request
func (o *GetIconParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param digest
	if err := r.SetPathParam("digest", o.Digest); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
