// Code generated by go-swagger; DO NOT EDIT.

package immutable

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDeleteImmuRuleParams creates a new DeleteImmuRuleParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteImmuRuleParams() *DeleteImmuRuleParams {
	return &DeleteImmuRuleParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteImmuRuleParamsWithTimeout creates a new DeleteImmuRuleParams object
// with the ability to set a timeout on a request.
func NewDeleteImmuRuleParamsWithTimeout(timeout time.Duration) *DeleteImmuRuleParams {
	return &DeleteImmuRuleParams{
		timeout: timeout,
	}
}

// NewDeleteImmuRuleParamsWithContext creates a new DeleteImmuRuleParams object
// with the ability to set a context for a request.
func NewDeleteImmuRuleParamsWithContext(ctx context.Context) *DeleteImmuRuleParams {
	return &DeleteImmuRuleParams{
		Context: ctx,
	}
}

// NewDeleteImmuRuleParamsWithHTTPClient creates a new DeleteImmuRuleParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteImmuRuleParamsWithHTTPClient(client *http.Client) *DeleteImmuRuleParams {
	return &DeleteImmuRuleParams{
		HTTPClient: client,
	}
}

/*
DeleteImmuRuleParams contains all the parameters to send to the API endpoint

	for the delete immu rule operation.

	Typically these are written to a http.Request.
*/
type DeleteImmuRuleParams struct {

	/* XIsResourceName.

	   The flag to indicate whether the parameter which supports both name and id in the path is the name of the resource. When the X-Is-Resource-Name is false and the parameter can be converted to an integer, the parameter will be as an id, otherwise, it will be as a name.
	*/
	XIsResourceName *bool

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* ImmutableRuleID.

	   The ID of the immutable rule

	   Format: int64
	*/
	ImmutableRuleID int64

	/* ProjectNameOrID.

	   The name or id of the project
	*/
	ProjectNameOrID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete immu rule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteImmuRuleParams) WithDefaults() *DeleteImmuRuleParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete immu rule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteImmuRuleParams) SetDefaults() {
	var (
		xIsResourceNameDefault = bool(false)
	)

	val := DeleteImmuRuleParams{
		XIsResourceName: &xIsResourceNameDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the delete immu rule params
func (o *DeleteImmuRuleParams) WithTimeout(timeout time.Duration) *DeleteImmuRuleParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete immu rule params
func (o *DeleteImmuRuleParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete immu rule params
func (o *DeleteImmuRuleParams) WithContext(ctx context.Context) *DeleteImmuRuleParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete immu rule params
func (o *DeleteImmuRuleParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete immu rule params
func (o *DeleteImmuRuleParams) WithHTTPClient(client *http.Client) *DeleteImmuRuleParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete immu rule params
func (o *DeleteImmuRuleParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXIsResourceName adds the xIsResourceName to the delete immu rule params
func (o *DeleteImmuRuleParams) WithXIsResourceName(xIsResourceName *bool) *DeleteImmuRuleParams {
	o.SetXIsResourceName(xIsResourceName)
	return o
}

// SetXIsResourceName adds the xIsResourceName to the delete immu rule params
func (o *DeleteImmuRuleParams) SetXIsResourceName(xIsResourceName *bool) {
	o.XIsResourceName = xIsResourceName
}

// WithXRequestID adds the xRequestID to the delete immu rule params
func (o *DeleteImmuRuleParams) WithXRequestID(xRequestID *string) *DeleteImmuRuleParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the delete immu rule params
func (o *DeleteImmuRuleParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithImmutableRuleID adds the immutableRuleID to the delete immu rule params
func (o *DeleteImmuRuleParams) WithImmutableRuleID(immutableRuleID int64) *DeleteImmuRuleParams {
	o.SetImmutableRuleID(immutableRuleID)
	return o
}

// SetImmutableRuleID adds the immutableRuleId to the delete immu rule params
func (o *DeleteImmuRuleParams) SetImmutableRuleID(immutableRuleID int64) {
	o.ImmutableRuleID = immutableRuleID
}

// WithProjectNameOrID adds the projectNameOrID to the delete immu rule params
func (o *DeleteImmuRuleParams) WithProjectNameOrID(projectNameOrID string) *DeleteImmuRuleParams {
	o.SetProjectNameOrID(projectNameOrID)
	return o
}

// SetProjectNameOrID adds the projectNameOrId to the delete immu rule params
func (o *DeleteImmuRuleParams) SetProjectNameOrID(projectNameOrID string) {
	o.ProjectNameOrID = projectNameOrID
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteImmuRuleParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XIsResourceName != nil {

		// header param X-Is-Resource-Name
		if err := r.SetHeaderParam("X-Is-Resource-Name", swag.FormatBool(*o.XIsResourceName)); err != nil {
			return err
		}
	}

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param immutable_rule_id
	if err := r.SetPathParam("immutable_rule_id", swag.FormatInt64(o.ImmutableRuleID)); err != nil {
		return err
	}

	// path param project_name_or_id
	if err := r.SetPathParam("project_name_or_id", o.ProjectNameOrID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
