// Code generated by go-swagger; DO NOT EDIT.

package oidc

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

//go:generate mockery -name API -inpkg

// API is the interface of the oidc client
type API interface {
	/*
	   PingOIDC tests the OIDC endpoint

	   Test the OIDC endpoint, the setting of the endpoint is provided in the request.  This API can only be called by system admin.
	*/
	PingOIDC(ctx context.Context, params *PingOIDCParams) (*PingOIDCOK, error)
}

// New creates a new oidc API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry, authInfo runtime.ClientAuthInfoWriter) *Client {
	return &Client{
		transport: transport,
		formats:   formats,
		authInfo:  authInfo,
	}
}

/*
Client for oidc API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
	authInfo  runtime.ClientAuthInfoWriter
}

/*
PingOIDC tests the OIDC endpoint

Test the OIDC endpoint, the setting of the endpoint is provided in the request.  This API can only be called by system admin.
*/
func (a *Client) PingOIDC(ctx context.Context, params *PingOIDCParams) (*PingOIDCOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "pingOIDC",
		Method:             "POST",
		PathPattern:        "/system/oidc/ping",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &PingOIDCReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*PingOIDCOK), nil

}
