// Code generated by go-swagger; DO NOT EDIT.

package preheat

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetPreheatLogParams creates a new GetPreheatLogParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetPreheatLogParams() *GetPreheatLogParams {
	return &GetPreheatLogParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetPreheatLogParamsWithTimeout creates a new GetPreheatLogParams object
// with the ability to set a timeout on a request.
func NewGetPreheatLogParamsWithTimeout(timeout time.Duration) *GetPreheatLogParams {
	return &GetPreheatLogParams{
		timeout: timeout,
	}
}

// NewGetPreheatLogParamsWithContext creates a new GetPreheatLogParams object
// with the ability to set a context for a request.
func NewGetPreheatLogParamsWithContext(ctx context.Context) *GetPreheatLogParams {
	return &GetPreheatLogParams{
		Context: ctx,
	}
}

// NewGetPreheatLogParamsWithHTTPClient creates a new GetPreheatLogParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetPreheatLogParamsWithHTTPClient(client *http.Client) *GetPreheatLogParams {
	return &GetPreheatLogParams{
		HTTPClient: client,
	}
}

/*
GetPreheatLogParams contains all the parameters to send to the API endpoint

	for the get preheat log operation.

	Typically these are written to a http.Request.
*/
type GetPreheatLogParams struct {

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* ExecutionID.

	   Execution ID
	*/
	ExecutionID int64

	/* PreheatPolicyName.

	   Preheat Policy Name
	*/
	PreheatPolicyName string

	/* ProjectName.

	   The name of the project
	*/
	ProjectName string

	/* TaskID.

	   Task ID
	*/
	TaskID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get preheat log params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetPreheatLogParams) WithDefaults() *GetPreheatLogParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get preheat log params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetPreheatLogParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get preheat log params
func (o *GetPreheatLogParams) WithTimeout(timeout time.Duration) *GetPreheatLogParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get preheat log params
func (o *GetPreheatLogParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get preheat log params
func (o *GetPreheatLogParams) WithContext(ctx context.Context) *GetPreheatLogParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get preheat log params
func (o *GetPreheatLogParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get preheat log params
func (o *GetPreheatLogParams) WithHTTPClient(client *http.Client) *GetPreheatLogParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get preheat log params
func (o *GetPreheatLogParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXRequestID adds the xRequestID to the get preheat log params
func (o *GetPreheatLogParams) WithXRequestID(xRequestID *string) *GetPreheatLogParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the get preheat log params
func (o *GetPreheatLogParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithExecutionID adds the executionID to the get preheat log params
func (o *GetPreheatLogParams) WithExecutionID(executionID int64) *GetPreheatLogParams {
	o.SetExecutionID(executionID)
	return o
}

// SetExecutionID adds the executionId to the get preheat log params
func (o *GetPreheatLogParams) SetExecutionID(executionID int64) {
	o.ExecutionID = executionID
}

// WithPreheatPolicyName adds the preheatPolicyName to the get preheat log params
func (o *GetPreheatLogParams) WithPreheatPolicyName(preheatPolicyName string) *GetPreheatLogParams {
	o.SetPreheatPolicyName(preheatPolicyName)
	return o
}

// SetPreheatPolicyName adds the preheatPolicyName to the get preheat log params
func (o *GetPreheatLogParams) SetPreheatPolicyName(preheatPolicyName string) {
	o.PreheatPolicyName = preheatPolicyName
}

// WithProjectName adds the projectName to the get preheat log params
func (o *GetPreheatLogParams) WithProjectName(projectName string) *GetPreheatLogParams {
	o.SetProjectName(projectName)
	return o
}

// SetProjectName adds the projectName to the get preheat log params
func (o *GetPreheatLogParams) SetProjectName(projectName string) {
	o.ProjectName = projectName
}

// WithTaskID adds the taskID to the get preheat log params
func (o *GetPreheatLogParams) WithTaskID(taskID int64) *GetPreheatLogParams {
	o.SetTaskID(taskID)
	return o
}

// SetTaskID adds the taskId to the get preheat log params
func (o *GetPreheatLogParams) SetTaskID(taskID int64) {
	o.TaskID = taskID
}

// WriteToRequest writes these params to a swagger request
func (o *GetPreheatLogParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param execution_id
	if err := r.SetPathParam("execution_id", swag.FormatInt64(o.ExecutionID)); err != nil {
		return err
	}

	// path param preheat_policy_name
	if err := r.SetPathParam("preheat_policy_name", o.PreheatPolicyName); err != nil {
		return err
	}

	// path param project_name
	if err := r.SetPathParam("project_name", o.ProjectName); err != nil {
		return err
	}

	// path param task_id
	if err := r.SetPathParam("task_id", swag.FormatInt64(o.TaskID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
