// Code generated by go-swagger; DO NOT EDIT.

package project

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// HeadProjectReader is a Reader for the HeadProject structure.
type HeadProjectReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *HeadProjectReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewHeadProjectOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewHeadProjectNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewHeadProjectInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewHeadProjectOK creates a HeadProjectOK with default headers values
func NewHeadProjectOK() *HeadProjectOK {
	return &HeadProjectOK{}
}

/*
HeadProjectOK describes a response with status code 200, with default header values.

Success
*/
type HeadProjectOK struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string
}

// IsSuccess returns true when this head project o k response has a 2xx status code
func (o *HeadProjectOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this head project o k response has a 3xx status code
func (o *HeadProjectOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this head project o k response has a 4xx status code
func (o *HeadProjectOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this head project o k response has a 5xx status code
func (o *HeadProjectOK) IsServerError() bool {
	return false
}

// IsCode returns true when this head project o k response a status code equal to that given
func (o *HeadProjectOK) IsCode(code int) bool {
	return code == 200
}

func (o *HeadProjectOK) Error() string {
	return fmt.Sprintf("[HEAD /projects][%d] headProjectOK ", 200)
}

func (o *HeadProjectOK) String() string {
	return fmt.Sprintf("[HEAD /projects][%d] headProjectOK ", 200)
}

func (o *HeadProjectOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	return nil
}

// NewHeadProjectNotFound creates a HeadProjectNotFound with default headers values
func NewHeadProjectNotFound() *HeadProjectNotFound {
	return &HeadProjectNotFound{}
}

/*
HeadProjectNotFound describes a response with status code 404, with default header values.

Not found
*/
type HeadProjectNotFound struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this head project not found response has a 2xx status code
func (o *HeadProjectNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this head project not found response has a 3xx status code
func (o *HeadProjectNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this head project not found response has a 4xx status code
func (o *HeadProjectNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this head project not found response has a 5xx status code
func (o *HeadProjectNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this head project not found response a status code equal to that given
func (o *HeadProjectNotFound) IsCode(code int) bool {
	return code == 404
}

func (o *HeadProjectNotFound) Error() string {
	return fmt.Sprintf("[HEAD /projects][%d] headProjectNotFound  %+v", 404, o.Payload)
}

func (o *HeadProjectNotFound) String() string {
	return fmt.Sprintf("[HEAD /projects][%d] headProjectNotFound  %+v", 404, o.Payload)
}

func (o *HeadProjectNotFound) GetPayload() *models.Errors {
	return o.Payload
}

func (o *HeadProjectNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewHeadProjectInternalServerError creates a HeadProjectInternalServerError with default headers values
func NewHeadProjectInternalServerError() *HeadProjectInternalServerError {
	return &HeadProjectInternalServerError{}
}

/*
HeadProjectInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type HeadProjectInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this head project internal server error response has a 2xx status code
func (o *HeadProjectInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this head project internal server error response has a 3xx status code
func (o *HeadProjectInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this head project internal server error response has a 4xx status code
func (o *HeadProjectInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this head project internal server error response has a 5xx status code
func (o *HeadProjectInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this head project internal server error response a status code equal to that given
func (o *HeadProjectInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *HeadProjectInternalServerError) Error() string {
	return fmt.Sprintf("[HEAD /projects][%d] headProjectInternalServerError  %+v", 500, o.Payload)
}

func (o *HeadProjectInternalServerError) String() string {
	return fmt.Sprintf("[HEAD /projects][%d] headProjectInternalServerError  %+v", 500, o.Payload)
}

func (o *HeadProjectInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *HeadProjectInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
