// Code generated by go-swagger; DO NOT EDIT.

package project_metadata

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// GetProjectMetadataReader is a Reader for the GetProjectMetadata structure.
type GetProjectMetadataReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetProjectMetadataReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetProjectMetadataOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewGetProjectMetadataBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewGetProjectMetadataUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetProjectMetadataForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetProjectMetadataNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetProjectMetadataInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetProjectMetadataOK creates a GetProjectMetadataOK with default headers values
func NewGetProjectMetadataOK() *GetProjectMetadataOK {
	return &GetProjectMetadataOK{}
}

/*
GetProjectMetadataOK describes a response with status code 200, with default header values.

Success
*/
type GetProjectMetadataOK struct {
	Payload map[string]string
}

// IsSuccess returns true when this get project metadata o k response has a 2xx status code
func (o *GetProjectMetadataOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get project metadata o k response has a 3xx status code
func (o *GetProjectMetadataOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get project metadata o k response has a 4xx status code
func (o *GetProjectMetadataOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get project metadata o k response has a 5xx status code
func (o *GetProjectMetadataOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get project metadata o k response a status code equal to that given
func (o *GetProjectMetadataOK) IsCode(code int) bool {
	return code == 200
}

func (o *GetProjectMetadataOK) Error() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataOK  %+v", 200, o.Payload)
}

func (o *GetProjectMetadataOK) String() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataOK  %+v", 200, o.Payload)
}

func (o *GetProjectMetadataOK) GetPayload() map[string]string {
	return o.Payload
}

func (o *GetProjectMetadataOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetProjectMetadataBadRequest creates a GetProjectMetadataBadRequest with default headers values
func NewGetProjectMetadataBadRequest() *GetProjectMetadataBadRequest {
	return &GetProjectMetadataBadRequest{}
}

/*
GetProjectMetadataBadRequest describes a response with status code 400, with default header values.

Bad request
*/
type GetProjectMetadataBadRequest struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get project metadata bad request response has a 2xx status code
func (o *GetProjectMetadataBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get project metadata bad request response has a 3xx status code
func (o *GetProjectMetadataBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get project metadata bad request response has a 4xx status code
func (o *GetProjectMetadataBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this get project metadata bad request response has a 5xx status code
func (o *GetProjectMetadataBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this get project metadata bad request response a status code equal to that given
func (o *GetProjectMetadataBadRequest) IsCode(code int) bool {
	return code == 400
}

func (o *GetProjectMetadataBadRequest) Error() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataBadRequest  %+v", 400, o.Payload)
}

func (o *GetProjectMetadataBadRequest) String() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataBadRequest  %+v", 400, o.Payload)
}

func (o *GetProjectMetadataBadRequest) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetProjectMetadataBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetProjectMetadataUnauthorized creates a GetProjectMetadataUnauthorized with default headers values
func NewGetProjectMetadataUnauthorized() *GetProjectMetadataUnauthorized {
	return &GetProjectMetadataUnauthorized{}
}

/*
GetProjectMetadataUnauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type GetProjectMetadataUnauthorized struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get project metadata unauthorized response has a 2xx status code
func (o *GetProjectMetadataUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get project metadata unauthorized response has a 3xx status code
func (o *GetProjectMetadataUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get project metadata unauthorized response has a 4xx status code
func (o *GetProjectMetadataUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get project metadata unauthorized response has a 5xx status code
func (o *GetProjectMetadataUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get project metadata unauthorized response a status code equal to that given
func (o *GetProjectMetadataUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *GetProjectMetadataUnauthorized) Error() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataUnauthorized  %+v", 401, o.Payload)
}

func (o *GetProjectMetadataUnauthorized) String() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataUnauthorized  %+v", 401, o.Payload)
}

func (o *GetProjectMetadataUnauthorized) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetProjectMetadataUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetProjectMetadataForbidden creates a GetProjectMetadataForbidden with default headers values
func NewGetProjectMetadataForbidden() *GetProjectMetadataForbidden {
	return &GetProjectMetadataForbidden{}
}

/*
GetProjectMetadataForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type GetProjectMetadataForbidden struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get project metadata forbidden response has a 2xx status code
func (o *GetProjectMetadataForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get project metadata forbidden response has a 3xx status code
func (o *GetProjectMetadataForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get project metadata forbidden response has a 4xx status code
func (o *GetProjectMetadataForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get project metadata forbidden response has a 5xx status code
func (o *GetProjectMetadataForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get project metadata forbidden response a status code equal to that given
func (o *GetProjectMetadataForbidden) IsCode(code int) bool {
	return code == 403
}

func (o *GetProjectMetadataForbidden) Error() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataForbidden  %+v", 403, o.Payload)
}

func (o *GetProjectMetadataForbidden) String() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataForbidden  %+v", 403, o.Payload)
}

func (o *GetProjectMetadataForbidden) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetProjectMetadataForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetProjectMetadataNotFound creates a GetProjectMetadataNotFound with default headers values
func NewGetProjectMetadataNotFound() *GetProjectMetadataNotFound {
	return &GetProjectMetadataNotFound{}
}

/*
GetProjectMetadataNotFound describes a response with status code 404, with default header values.

Not found
*/
type GetProjectMetadataNotFound struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get project metadata not found response has a 2xx status code
func (o *GetProjectMetadataNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get project metadata not found response has a 3xx status code
func (o *GetProjectMetadataNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get project metadata not found response has a 4xx status code
func (o *GetProjectMetadataNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get project metadata not found response has a 5xx status code
func (o *GetProjectMetadataNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get project metadata not found response a status code equal to that given
func (o *GetProjectMetadataNotFound) IsCode(code int) bool {
	return code == 404
}

func (o *GetProjectMetadataNotFound) Error() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataNotFound  %+v", 404, o.Payload)
}

func (o *GetProjectMetadataNotFound) String() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataNotFound  %+v", 404, o.Payload)
}

func (o *GetProjectMetadataNotFound) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetProjectMetadataNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetProjectMetadataInternalServerError creates a GetProjectMetadataInternalServerError with default headers values
func NewGetProjectMetadataInternalServerError() *GetProjectMetadataInternalServerError {
	return &GetProjectMetadataInternalServerError{}
}

/*
GetProjectMetadataInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type GetProjectMetadataInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get project metadata internal server error response has a 2xx status code
func (o *GetProjectMetadataInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get project metadata internal server error response has a 3xx status code
func (o *GetProjectMetadataInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get project metadata internal server error response has a 4xx status code
func (o *GetProjectMetadataInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get project metadata internal server error response has a 5xx status code
func (o *GetProjectMetadataInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get project metadata internal server error response a status code equal to that given
func (o *GetProjectMetadataInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *GetProjectMetadataInternalServerError) Error() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataInternalServerError  %+v", 500, o.Payload)
}

func (o *GetProjectMetadataInternalServerError) String() string {
	return fmt.Sprintf("[GET /projects/{project_name_or_id}/metadatas/{meta_name}][%d] getProjectMetadataInternalServerError  %+v", 500, o.Payload)
}

func (o *GetProjectMetadataInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetProjectMetadataInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
