// Code generated by go-swagger; DO NOT EDIT.

package purge

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetPurgeJobParams creates a new GetPurgeJobParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetPurgeJobParams() *GetPurgeJobParams {
	return &GetPurgeJobParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetPurgeJobParamsWithTimeout creates a new GetPurgeJobParams object
// with the ability to set a timeout on a request.
func NewGetPurgeJobParamsWithTimeout(timeout time.Duration) *GetPurgeJobParams {
	return &GetPurgeJobParams{
		timeout: timeout,
	}
}

// NewGetPurgeJobParamsWithContext creates a new GetPurgeJobParams object
// with the ability to set a context for a request.
func NewGetPurgeJobParamsWithContext(ctx context.Context) *GetPurgeJobParams {
	return &GetPurgeJobParams{
		Context: ctx,
	}
}

// NewGetPurgeJobParamsWithHTTPClient creates a new GetPurgeJobParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetPurgeJobParamsWithHTTPClient(client *http.Client) *GetPurgeJobParams {
	return &GetPurgeJobParams{
		HTTPClient: client,
	}
}

/*
GetPurgeJobParams contains all the parameters to send to the API endpoint

	for the get purge job operation.

	Typically these are written to a http.Request.
*/
type GetPurgeJobParams struct {

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* PurgeID.

	   The ID of the purge log

	   Format: int64
	*/
	PurgeID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get purge job params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetPurgeJobParams) WithDefaults() *GetPurgeJobParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get purge job params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetPurgeJobParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get purge job params
func (o *GetPurgeJobParams) WithTimeout(timeout time.Duration) *GetPurgeJobParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get purge job params
func (o *GetPurgeJobParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get purge job params
func (o *GetPurgeJobParams) WithContext(ctx context.Context) *GetPurgeJobParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get purge job params
func (o *GetPurgeJobParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get purge job params
func (o *GetPurgeJobParams) WithHTTPClient(client *http.Client) *GetPurgeJobParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get purge job params
func (o *GetPurgeJobParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXRequestID adds the xRequestID to the get purge job params
func (o *GetPurgeJobParams) WithXRequestID(xRequestID *string) *GetPurgeJobParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the get purge job params
func (o *GetPurgeJobParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithPurgeID adds the purgeID to the get purge job params
func (o *GetPurgeJobParams) WithPurgeID(purgeID int64) *GetPurgeJobParams {
	o.SetPurgeID(purgeID)
	return o
}

// SetPurgeID adds the purgeId to the get purge job params
func (o *GetPurgeJobParams) SetPurgeID(purgeID int64) {
	o.PurgeID = purgeID
}

// WriteToRequest writes these params to a swagger request
func (o *GetPurgeJobParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param purge_id
	if err := r.SetPathParam("purge_id", swag.FormatInt64(o.PurgeID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
