// Code generated by go-swagger; DO NOT EDIT.

package purge

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// GetPurgeJobReader is a Reader for the GetPurgeJob structure.
type GetPurgeJobReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPurgeJobReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPurgeJobOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetPurgeJobUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetPurgeJobForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetPurgeJobNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetPurgeJobInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetPurgeJobOK creates a GetPurgeJobOK with default headers values
func NewGetPurgeJobOK() *GetPurgeJobOK {
	return &GetPurgeJobOK{}
}

/*
GetPurgeJobOK describes a response with status code 200, with default header values.

Get purge job results successfully.
*/
type GetPurgeJobOK struct {
	Payload *models.ExecHistory
}

// IsSuccess returns true when this get purge job o k response has a 2xx status code
func (o *GetPurgeJobOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get purge job o k response has a 3xx status code
func (o *GetPurgeJobOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get purge job o k response has a 4xx status code
func (o *GetPurgeJobOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get purge job o k response has a 5xx status code
func (o *GetPurgeJobOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get purge job o k response a status code equal to that given
func (o *GetPurgeJobOK) IsCode(code int) bool {
	return code == 200
}

func (o *GetPurgeJobOK) Error() string {
	return fmt.Sprintf("[GET /system/purgeaudit/{purge_id}][%d] getPurgeJobOK  %+v", 200, o.Payload)
}

func (o *GetPurgeJobOK) String() string {
	return fmt.Sprintf("[GET /system/purgeaudit/{purge_id}][%d] getPurgeJobOK  %+v", 200, o.Payload)
}

func (o *GetPurgeJobOK) GetPayload() *models.ExecHistory {
	return o.Payload
}

func (o *GetPurgeJobOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ExecHistory)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPurgeJobUnauthorized creates a GetPurgeJobUnauthorized with default headers values
func NewGetPurgeJobUnauthorized() *GetPurgeJobUnauthorized {
	return &GetPurgeJobUnauthorized{}
}

/*
GetPurgeJobUnauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type GetPurgeJobUnauthorized struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get purge job unauthorized response has a 2xx status code
func (o *GetPurgeJobUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get purge job unauthorized response has a 3xx status code
func (o *GetPurgeJobUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get purge job unauthorized response has a 4xx status code
func (o *GetPurgeJobUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get purge job unauthorized response has a 5xx status code
func (o *GetPurgeJobUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get purge job unauthorized response a status code equal to that given
func (o *GetPurgeJobUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *GetPurgeJobUnauthorized) Error() string {
	return fmt.Sprintf("[GET /system/purgeaudit/{purge_id}][%d] getPurgeJobUnauthorized  %+v", 401, o.Payload)
}

func (o *GetPurgeJobUnauthorized) String() string {
	return fmt.Sprintf("[GET /system/purgeaudit/{purge_id}][%d] getPurgeJobUnauthorized  %+v", 401, o.Payload)
}

func (o *GetPurgeJobUnauthorized) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetPurgeJobUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPurgeJobForbidden creates a GetPurgeJobForbidden with default headers values
func NewGetPurgeJobForbidden() *GetPurgeJobForbidden {
	return &GetPurgeJobForbidden{}
}

/*
GetPurgeJobForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type GetPurgeJobForbidden struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get purge job forbidden response has a 2xx status code
func (o *GetPurgeJobForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get purge job forbidden response has a 3xx status code
func (o *GetPurgeJobForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get purge job forbidden response has a 4xx status code
func (o *GetPurgeJobForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get purge job forbidden response has a 5xx status code
func (o *GetPurgeJobForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get purge job forbidden response a status code equal to that given
func (o *GetPurgeJobForbidden) IsCode(code int) bool {
	return code == 403
}

func (o *GetPurgeJobForbidden) Error() string {
	return fmt.Sprintf("[GET /system/purgeaudit/{purge_id}][%d] getPurgeJobForbidden  %+v", 403, o.Payload)
}

func (o *GetPurgeJobForbidden) String() string {
	return fmt.Sprintf("[GET /system/purgeaudit/{purge_id}][%d] getPurgeJobForbidden  %+v", 403, o.Payload)
}

func (o *GetPurgeJobForbidden) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetPurgeJobForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPurgeJobNotFound creates a GetPurgeJobNotFound with default headers values
func NewGetPurgeJobNotFound() *GetPurgeJobNotFound {
	return &GetPurgeJobNotFound{}
}

/*
GetPurgeJobNotFound describes a response with status code 404, with default header values.

Not found
*/
type GetPurgeJobNotFound struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get purge job not found response has a 2xx status code
func (o *GetPurgeJobNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get purge job not found response has a 3xx status code
func (o *GetPurgeJobNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get purge job not found response has a 4xx status code
func (o *GetPurgeJobNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get purge job not found response has a 5xx status code
func (o *GetPurgeJobNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get purge job not found response a status code equal to that given
func (o *GetPurgeJobNotFound) IsCode(code int) bool {
	return code == 404
}

func (o *GetPurgeJobNotFound) Error() string {
	return fmt.Sprintf("[GET /system/purgeaudit/{purge_id}][%d] getPurgeJobNotFound  %+v", 404, o.Payload)
}

func (o *GetPurgeJobNotFound) String() string {
	return fmt.Sprintf("[GET /system/purgeaudit/{purge_id}][%d] getPurgeJobNotFound  %+v", 404, o.Payload)
}

func (o *GetPurgeJobNotFound) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetPurgeJobNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPurgeJobInternalServerError creates a GetPurgeJobInternalServerError with default headers values
func NewGetPurgeJobInternalServerError() *GetPurgeJobInternalServerError {
	return &GetPurgeJobInternalServerError{}
}

/*
GetPurgeJobInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type GetPurgeJobInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get purge job internal server error response has a 2xx status code
func (o *GetPurgeJobInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get purge job internal server error response has a 3xx status code
func (o *GetPurgeJobInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get purge job internal server error response has a 4xx status code
func (o *GetPurgeJobInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get purge job internal server error response has a 5xx status code
func (o *GetPurgeJobInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get purge job internal server error response a status code equal to that given
func (o *GetPurgeJobInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *GetPurgeJobInternalServerError) Error() string {
	return fmt.Sprintf("[GET /system/purgeaudit/{purge_id}][%d] getPurgeJobInternalServerError  %+v", 500, o.Payload)
}

func (o *GetPurgeJobInternalServerError) String() string {
	return fmt.Sprintf("[GET /system/purgeaudit/{purge_id}][%d] getPurgeJobInternalServerError  %+v", 500, o.Payload)
}

func (o *GetPurgeJobInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetPurgeJobInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
