// Code generated by go-swagger; DO NOT EDIT.

package registry

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDeleteRegistryParams creates a new DeleteRegistryParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteRegistryParams() *DeleteRegistryParams {
	return &DeleteRegistryParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteRegistryParamsWithTimeout creates a new DeleteRegistryParams object
// with the ability to set a timeout on a request.
func NewDeleteRegistryParamsWithTimeout(timeout time.Duration) *DeleteRegistryParams {
	return &DeleteRegistryParams{
		timeout: timeout,
	}
}

// NewDeleteRegistryParamsWithContext creates a new DeleteRegistryParams object
// with the ability to set a context for a request.
func NewDeleteRegistryParamsWithContext(ctx context.Context) *DeleteRegistryParams {
	return &DeleteRegistryParams{
		Context: ctx,
	}
}

// NewDeleteRegistryParamsWithHTTPClient creates a new DeleteRegistryParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteRegistryParamsWithHTTPClient(client *http.Client) *DeleteRegistryParams {
	return &DeleteRegistryParams{
		HTTPClient: client,
	}
}

/*
DeleteRegistryParams contains all the parameters to send to the API endpoint

	for the delete registry operation.

	Typically these are written to a http.Request.
*/
type DeleteRegistryParams struct {

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* ID.

	   Registry ID

	   Format: int64
	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete registry params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteRegistryParams) WithDefaults() *DeleteRegistryParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete registry params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteRegistryParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete registry params
func (o *DeleteRegistryParams) WithTimeout(timeout time.Duration) *DeleteRegistryParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete registry params
func (o *DeleteRegistryParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete registry params
func (o *DeleteRegistryParams) WithContext(ctx context.Context) *DeleteRegistryParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete registry params
func (o *DeleteRegistryParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete registry params
func (o *DeleteRegistryParams) WithHTTPClient(client *http.Client) *DeleteRegistryParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete registry params
func (o *DeleteRegistryParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXRequestID adds the xRequestID to the delete registry params
func (o *DeleteRegistryParams) WithXRequestID(xRequestID *string) *DeleteRegistryParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the delete registry params
func (o *DeleteRegistryParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithID adds the id to the delete registry params
func (o *DeleteRegistryParams) WithID(id int64) *DeleteRegistryParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the delete registry params
func (o *DeleteRegistryParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteRegistryParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
