// Code generated by go-swagger; DO NOT EDIT.

package registry

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// GetRegistryInfoReader is a Reader for the GetRegistryInfo structure.
type GetRegistryInfoReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRegistryInfoReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRegistryInfoOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetRegistryInfoUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetRegistryInfoForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetRegistryInfoNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetRegistryInfoInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetRegistryInfoOK creates a GetRegistryInfoOK with default headers values
func NewGetRegistryInfoOK() *GetRegistryInfoOK {
	return &GetRegistryInfoOK{}
}

/*
GetRegistryInfoOK describes a response with status code 200, with default header values.

Success
*/
type GetRegistryInfoOK struct {
	Payload *models.RegistryInfo
}

// IsSuccess returns true when this get registry info o k response has a 2xx status code
func (o *GetRegistryInfoOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get registry info o k response has a 3xx status code
func (o *GetRegistryInfoOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get registry info o k response has a 4xx status code
func (o *GetRegistryInfoOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get registry info o k response has a 5xx status code
func (o *GetRegistryInfoOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get registry info o k response a status code equal to that given
func (o *GetRegistryInfoOK) IsCode(code int) bool {
	return code == 200
}

func (o *GetRegistryInfoOK) Error() string {
	return fmt.Sprintf("[GET /registries/{id}/info][%d] getRegistryInfoOK  %+v", 200, o.Payload)
}

func (o *GetRegistryInfoOK) String() string {
	return fmt.Sprintf("[GET /registries/{id}/info][%d] getRegistryInfoOK  %+v", 200, o.Payload)
}

func (o *GetRegistryInfoOK) GetPayload() *models.RegistryInfo {
	return o.Payload
}

func (o *GetRegistryInfoOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RegistryInfo)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegistryInfoUnauthorized creates a GetRegistryInfoUnauthorized with default headers values
func NewGetRegistryInfoUnauthorized() *GetRegistryInfoUnauthorized {
	return &GetRegistryInfoUnauthorized{}
}

/*
GetRegistryInfoUnauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type GetRegistryInfoUnauthorized struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get registry info unauthorized response has a 2xx status code
func (o *GetRegistryInfoUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get registry info unauthorized response has a 3xx status code
func (o *GetRegistryInfoUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get registry info unauthorized response has a 4xx status code
func (o *GetRegistryInfoUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get registry info unauthorized response has a 5xx status code
func (o *GetRegistryInfoUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get registry info unauthorized response a status code equal to that given
func (o *GetRegistryInfoUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *GetRegistryInfoUnauthorized) Error() string {
	return fmt.Sprintf("[GET /registries/{id}/info][%d] getRegistryInfoUnauthorized  %+v", 401, o.Payload)
}

func (o *GetRegistryInfoUnauthorized) String() string {
	return fmt.Sprintf("[GET /registries/{id}/info][%d] getRegistryInfoUnauthorized  %+v", 401, o.Payload)
}

func (o *GetRegistryInfoUnauthorized) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetRegistryInfoUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegistryInfoForbidden creates a GetRegistryInfoForbidden with default headers values
func NewGetRegistryInfoForbidden() *GetRegistryInfoForbidden {
	return &GetRegistryInfoForbidden{}
}

/*
GetRegistryInfoForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type GetRegistryInfoForbidden struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get registry info forbidden response has a 2xx status code
func (o *GetRegistryInfoForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get registry info forbidden response has a 3xx status code
func (o *GetRegistryInfoForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get registry info forbidden response has a 4xx status code
func (o *GetRegistryInfoForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get registry info forbidden response has a 5xx status code
func (o *GetRegistryInfoForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get registry info forbidden response a status code equal to that given
func (o *GetRegistryInfoForbidden) IsCode(code int) bool {
	return code == 403
}

func (o *GetRegistryInfoForbidden) Error() string {
	return fmt.Sprintf("[GET /registries/{id}/info][%d] getRegistryInfoForbidden  %+v", 403, o.Payload)
}

func (o *GetRegistryInfoForbidden) String() string {
	return fmt.Sprintf("[GET /registries/{id}/info][%d] getRegistryInfoForbidden  %+v", 403, o.Payload)
}

func (o *GetRegistryInfoForbidden) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetRegistryInfoForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegistryInfoNotFound creates a GetRegistryInfoNotFound with default headers values
func NewGetRegistryInfoNotFound() *GetRegistryInfoNotFound {
	return &GetRegistryInfoNotFound{}
}

/*
GetRegistryInfoNotFound describes a response with status code 404, with default header values.

Not found
*/
type GetRegistryInfoNotFound struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get registry info not found response has a 2xx status code
func (o *GetRegistryInfoNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get registry info not found response has a 3xx status code
func (o *GetRegistryInfoNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get registry info not found response has a 4xx status code
func (o *GetRegistryInfoNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get registry info not found response has a 5xx status code
func (o *GetRegistryInfoNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get registry info not found response a status code equal to that given
func (o *GetRegistryInfoNotFound) IsCode(code int) bool {
	return code == 404
}

func (o *GetRegistryInfoNotFound) Error() string {
	return fmt.Sprintf("[GET /registries/{id}/info][%d] getRegistryInfoNotFound  %+v", 404, o.Payload)
}

func (o *GetRegistryInfoNotFound) String() string {
	return fmt.Sprintf("[GET /registries/{id}/info][%d] getRegistryInfoNotFound  %+v", 404, o.Payload)
}

func (o *GetRegistryInfoNotFound) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetRegistryInfoNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRegistryInfoInternalServerError creates a GetRegistryInfoInternalServerError with default headers values
func NewGetRegistryInfoInternalServerError() *GetRegistryInfoInternalServerError {
	return &GetRegistryInfoInternalServerError{}
}

/*
GetRegistryInfoInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type GetRegistryInfoInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get registry info internal server error response has a 2xx status code
func (o *GetRegistryInfoInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get registry info internal server error response has a 3xx status code
func (o *GetRegistryInfoInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get registry info internal server error response has a 4xx status code
func (o *GetRegistryInfoInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get registry info internal server error response has a 5xx status code
func (o *GetRegistryInfoInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get registry info internal server error response a status code equal to that given
func (o *GetRegistryInfoInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *GetRegistryInfoInternalServerError) Error() string {
	return fmt.Sprintf("[GET /registries/{id}/info][%d] getRegistryInfoInternalServerError  %+v", 500, o.Payload)
}

func (o *GetRegistryInfoInternalServerError) String() string {
	return fmt.Sprintf("[GET /registries/{id}/info][%d] getRegistryInfoInternalServerError  %+v", 500, o.Payload)
}

func (o *GetRegistryInfoInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetRegistryInfoInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
