// Code generated by go-swagger; DO NOT EDIT.

package registry

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

//go:generate mockery -name API -inpkg

// API is the interface of the registry client
type API interface {
	/*
	   CreateRegistry creates a registry

	   Create a registry*/
	CreateRegistry(ctx context.Context, params *CreateRegistryParams) (*CreateRegistryCreated, error)
	/*
	   DeleteRegistry deletes the specific registry

	   Delete the specific registry*/
	DeleteRegistry(ctx context.Context, params *DeleteRegistryParams) (*DeleteRegistryOK, error)
	/*
	   GetRegistry gets the specific registry

	   Get the specific registry*/
	GetRegistry(ctx context.Context, params *GetRegistryParams) (*GetRegistryOK, error)
	/*
	   GetRegistryInfo gets the registry info

	   Get the registry info*/
	GetRegistryInfo(ctx context.Context, params *GetRegistryInfoParams) (*GetRegistryInfoOK, error)
	/*
	   ListRegistries lists the registries

	   List the registries*/
	ListRegistries(ctx context.Context, params *ListRegistriesParams) (*ListRegistriesOK, error)
	/*
	   ListRegistryProviderInfos lists all registered registry provider information

	   List all registered registry provider information*/
	ListRegistryProviderInfos(ctx context.Context, params *ListRegistryProviderInfosParams) (*ListRegistryProviderInfosOK, error)
	/*
	   ListRegistryProviderTypes lists registry adapters

	   List registry adapters*/
	ListRegistryProviderTypes(ctx context.Context, params *ListRegistryProviderTypesParams) (*ListRegistryProviderTypesOK, error)
	/*
	   PingRegistry checks status of a registry

	   Check status of a registry*/
	PingRegistry(ctx context.Context, params *PingRegistryParams) (*PingRegistryOK, error)
	/*
	   UpdateRegistry updates the registry

	   Update the registry*/
	UpdateRegistry(ctx context.Context, params *UpdateRegistryParams) (*UpdateRegistryOK, error)
}

// New creates a new registry API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry, authInfo runtime.ClientAuthInfoWriter) *Client {
	return &Client{
		transport: transport,
		formats:   formats,
		authInfo:  authInfo,
	}
}

/*
Client for registry API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
	authInfo  runtime.ClientAuthInfoWriter
}

/*
CreateRegistry creates a registry

Create a registry
*/
func (a *Client) CreateRegistry(ctx context.Context, params *CreateRegistryParams) (*CreateRegistryCreated, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "createRegistry",
		Method:             "POST",
		PathPattern:        "/registries",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &CreateRegistryReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*CreateRegistryCreated), nil

}

/*
DeleteRegistry deletes the specific registry

Delete the specific registry
*/
func (a *Client) DeleteRegistry(ctx context.Context, params *DeleteRegistryParams) (*DeleteRegistryOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteRegistry",
		Method:             "DELETE",
		PathPattern:        "/registries/{id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &DeleteRegistryReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*DeleteRegistryOK), nil

}

/*
GetRegistry gets the specific registry

Get the specific registry
*/
func (a *Client) GetRegistry(ctx context.Context, params *GetRegistryParams) (*GetRegistryOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getRegistry",
		Method:             "GET",
		PathPattern:        "/registries/{id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetRegistryReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetRegistryOK), nil

}

/*
GetRegistryInfo gets the registry info

Get the registry info
*/
func (a *Client) GetRegistryInfo(ctx context.Context, params *GetRegistryInfoParams) (*GetRegistryInfoOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getRegistryInfo",
		Method:             "GET",
		PathPattern:        "/registries/{id}/info",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetRegistryInfoReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetRegistryInfoOK), nil

}

/*
ListRegistries lists the registries

List the registries
*/
func (a *Client) ListRegistries(ctx context.Context, params *ListRegistriesParams) (*ListRegistriesOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "listRegistries",
		Method:             "GET",
		PathPattern:        "/registries",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ListRegistriesReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*ListRegistriesOK), nil

}

/*
ListRegistryProviderInfos lists all registered registry provider information

List all registered registry provider information
*/
func (a *Client) ListRegistryProviderInfos(ctx context.Context, params *ListRegistryProviderInfosParams) (*ListRegistryProviderInfosOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "listRegistryProviderInfos",
		Method:             "GET",
		PathPattern:        "/replication/adapterinfos",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ListRegistryProviderInfosReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*ListRegistryProviderInfosOK), nil

}

/*
ListRegistryProviderTypes lists registry adapters

List registry adapters
*/
func (a *Client) ListRegistryProviderTypes(ctx context.Context, params *ListRegistryProviderTypesParams) (*ListRegistryProviderTypesOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "listRegistryProviderTypes",
		Method:             "GET",
		PathPattern:        "/replication/adapters",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ListRegistryProviderTypesReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*ListRegistryProviderTypesOK), nil

}

/*
PingRegistry checks status of a registry

Check status of a registry
*/
func (a *Client) PingRegistry(ctx context.Context, params *PingRegistryParams) (*PingRegistryOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "pingRegistry",
		Method:             "POST",
		PathPattern:        "/registries/ping",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &PingRegistryReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*PingRegistryOK), nil

}

/*
UpdateRegistry updates the registry

Update the registry
*/
func (a *Client) UpdateRegistry(ctx context.Context, params *UpdateRegistryParams) (*UpdateRegistryOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "updateRegistry",
		Method:             "PUT",
		PathPattern:        "/registries/{id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &UpdateRegistryReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*UpdateRegistryOK), nil

}
