// Code generated by go-swagger; DO NOT EDIT.

package replication

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// CreateReplicationPolicyReader is a Reader for the CreateReplicationPolicy structure.
type CreateReplicationPolicyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateReplicationPolicyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewCreateReplicationPolicyCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewCreateReplicationPolicyBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewCreateReplicationPolicyUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewCreateReplicationPolicyForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 409:
		result := NewCreateReplicationPolicyConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewCreateReplicationPolicyInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewCreateReplicationPolicyCreated creates a CreateReplicationPolicyCreated with default headers values
func NewCreateReplicationPolicyCreated() *CreateReplicationPolicyCreated {
	return &CreateReplicationPolicyCreated{}
}

/*
CreateReplicationPolicyCreated describes a response with status code 201, with default header values.

Created
*/
type CreateReplicationPolicyCreated struct {

	/* The location of the resource
	 */
	Location string

	/* The ID of the corresponding request for the response
	 */
	XRequestID string
}

// IsSuccess returns true when this create replication policy created response has a 2xx status code
func (o *CreateReplicationPolicyCreated) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this create replication policy created response has a 3xx status code
func (o *CreateReplicationPolicyCreated) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create replication policy created response has a 4xx status code
func (o *CreateReplicationPolicyCreated) IsClientError() bool {
	return false
}

// IsServerError returns true when this create replication policy created response has a 5xx status code
func (o *CreateReplicationPolicyCreated) IsServerError() bool {
	return false
}

// IsCode returns true when this create replication policy created response a status code equal to that given
func (o *CreateReplicationPolicyCreated) IsCode(code int) bool {
	return code == 201
}

func (o *CreateReplicationPolicyCreated) Error() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyCreated ", 201)
}

func (o *CreateReplicationPolicyCreated) String() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyCreated ", 201)
}

func (o *CreateReplicationPolicyCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Location
	hdrLocation := response.GetHeader("Location")

	if hdrLocation != "" {
		o.Location = hdrLocation
	}

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	return nil
}

// NewCreateReplicationPolicyBadRequest creates a CreateReplicationPolicyBadRequest with default headers values
func NewCreateReplicationPolicyBadRequest() *CreateReplicationPolicyBadRequest {
	return &CreateReplicationPolicyBadRequest{}
}

/*
CreateReplicationPolicyBadRequest describes a response with status code 400, with default header values.

Bad request
*/
type CreateReplicationPolicyBadRequest struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create replication policy bad request response has a 2xx status code
func (o *CreateReplicationPolicyBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create replication policy bad request response has a 3xx status code
func (o *CreateReplicationPolicyBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create replication policy bad request response has a 4xx status code
func (o *CreateReplicationPolicyBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this create replication policy bad request response has a 5xx status code
func (o *CreateReplicationPolicyBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this create replication policy bad request response a status code equal to that given
func (o *CreateReplicationPolicyBadRequest) IsCode(code int) bool {
	return code == 400
}

func (o *CreateReplicationPolicyBadRequest) Error() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyBadRequest  %+v", 400, o.Payload)
}

func (o *CreateReplicationPolicyBadRequest) String() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyBadRequest  %+v", 400, o.Payload)
}

func (o *CreateReplicationPolicyBadRequest) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateReplicationPolicyBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateReplicationPolicyUnauthorized creates a CreateReplicationPolicyUnauthorized with default headers values
func NewCreateReplicationPolicyUnauthorized() *CreateReplicationPolicyUnauthorized {
	return &CreateReplicationPolicyUnauthorized{}
}

/*
CreateReplicationPolicyUnauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type CreateReplicationPolicyUnauthorized struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create replication policy unauthorized response has a 2xx status code
func (o *CreateReplicationPolicyUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create replication policy unauthorized response has a 3xx status code
func (o *CreateReplicationPolicyUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create replication policy unauthorized response has a 4xx status code
func (o *CreateReplicationPolicyUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this create replication policy unauthorized response has a 5xx status code
func (o *CreateReplicationPolicyUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this create replication policy unauthorized response a status code equal to that given
func (o *CreateReplicationPolicyUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *CreateReplicationPolicyUnauthorized) Error() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyUnauthorized  %+v", 401, o.Payload)
}

func (o *CreateReplicationPolicyUnauthorized) String() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyUnauthorized  %+v", 401, o.Payload)
}

func (o *CreateReplicationPolicyUnauthorized) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateReplicationPolicyUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateReplicationPolicyForbidden creates a CreateReplicationPolicyForbidden with default headers values
func NewCreateReplicationPolicyForbidden() *CreateReplicationPolicyForbidden {
	return &CreateReplicationPolicyForbidden{}
}

/*
CreateReplicationPolicyForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type CreateReplicationPolicyForbidden struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create replication policy forbidden response has a 2xx status code
func (o *CreateReplicationPolicyForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create replication policy forbidden response has a 3xx status code
func (o *CreateReplicationPolicyForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create replication policy forbidden response has a 4xx status code
func (o *CreateReplicationPolicyForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this create replication policy forbidden response has a 5xx status code
func (o *CreateReplicationPolicyForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this create replication policy forbidden response a status code equal to that given
func (o *CreateReplicationPolicyForbidden) IsCode(code int) bool {
	return code == 403
}

func (o *CreateReplicationPolicyForbidden) Error() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyForbidden  %+v", 403, o.Payload)
}

func (o *CreateReplicationPolicyForbidden) String() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyForbidden  %+v", 403, o.Payload)
}

func (o *CreateReplicationPolicyForbidden) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateReplicationPolicyForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateReplicationPolicyConflict creates a CreateReplicationPolicyConflict with default headers values
func NewCreateReplicationPolicyConflict() *CreateReplicationPolicyConflict {
	return &CreateReplicationPolicyConflict{}
}

/*
CreateReplicationPolicyConflict describes a response with status code 409, with default header values.

Conflict
*/
type CreateReplicationPolicyConflict struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create replication policy conflict response has a 2xx status code
func (o *CreateReplicationPolicyConflict) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create replication policy conflict response has a 3xx status code
func (o *CreateReplicationPolicyConflict) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create replication policy conflict response has a 4xx status code
func (o *CreateReplicationPolicyConflict) IsClientError() bool {
	return true
}

// IsServerError returns true when this create replication policy conflict response has a 5xx status code
func (o *CreateReplicationPolicyConflict) IsServerError() bool {
	return false
}

// IsCode returns true when this create replication policy conflict response a status code equal to that given
func (o *CreateReplicationPolicyConflict) IsCode(code int) bool {
	return code == 409
}

func (o *CreateReplicationPolicyConflict) Error() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyConflict  %+v", 409, o.Payload)
}

func (o *CreateReplicationPolicyConflict) String() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyConflict  %+v", 409, o.Payload)
}

func (o *CreateReplicationPolicyConflict) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateReplicationPolicyConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateReplicationPolicyInternalServerError creates a CreateReplicationPolicyInternalServerError with default headers values
func NewCreateReplicationPolicyInternalServerError() *CreateReplicationPolicyInternalServerError {
	return &CreateReplicationPolicyInternalServerError{}
}

/*
CreateReplicationPolicyInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type CreateReplicationPolicyInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create replication policy internal server error response has a 2xx status code
func (o *CreateReplicationPolicyInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create replication policy internal server error response has a 3xx status code
func (o *CreateReplicationPolicyInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create replication policy internal server error response has a 4xx status code
func (o *CreateReplicationPolicyInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this create replication policy internal server error response has a 5xx status code
func (o *CreateReplicationPolicyInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this create replication policy internal server error response a status code equal to that given
func (o *CreateReplicationPolicyInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *CreateReplicationPolicyInternalServerError) Error() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateReplicationPolicyInternalServerError) String() string {
	return fmt.Sprintf("[POST /replication/policies][%d] createReplicationPolicyInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateReplicationPolicyInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateReplicationPolicyInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
