// Code generated by go-swagger; DO NOT EDIT.

package replication

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetReplicationPolicyParams creates a new GetReplicationPolicyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetReplicationPolicyParams() *GetReplicationPolicyParams {
	return &GetReplicationPolicyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetReplicationPolicyParamsWithTimeout creates a new GetReplicationPolicyParams object
// with the ability to set a timeout on a request.
func NewGetReplicationPolicyParamsWithTimeout(timeout time.Duration) *GetReplicationPolicyParams {
	return &GetReplicationPolicyParams{
		timeout: timeout,
	}
}

// NewGetReplicationPolicyParamsWithContext creates a new GetReplicationPolicyParams object
// with the ability to set a context for a request.
func NewGetReplicationPolicyParamsWithContext(ctx context.Context) *GetReplicationPolicyParams {
	return &GetReplicationPolicyParams{
		Context: ctx,
	}
}

// NewGetReplicationPolicyParamsWithHTTPClient creates a new GetReplicationPolicyParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetReplicationPolicyParamsWithHTTPClient(client *http.Client) *GetReplicationPolicyParams {
	return &GetReplicationPolicyParams{
		HTTPClient: client,
	}
}

/*
GetReplicationPolicyParams contains all the parameters to send to the API endpoint

	for the get replication policy operation.

	Typically these are written to a http.Request.
*/
type GetReplicationPolicyParams struct {

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* ID.

	   Policy ID

	   Format: int64
	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get replication policy params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetReplicationPolicyParams) WithDefaults() *GetReplicationPolicyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get replication policy params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetReplicationPolicyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get replication policy params
func (o *GetReplicationPolicyParams) WithTimeout(timeout time.Duration) *GetReplicationPolicyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get replication policy params
func (o *GetReplicationPolicyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get replication policy params
func (o *GetReplicationPolicyParams) WithContext(ctx context.Context) *GetReplicationPolicyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get replication policy params
func (o *GetReplicationPolicyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get replication policy params
func (o *GetReplicationPolicyParams) WithHTTPClient(client *http.Client) *GetReplicationPolicyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get replication policy params
func (o *GetReplicationPolicyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXRequestID adds the xRequestID to the get replication policy params
func (o *GetReplicationPolicyParams) WithXRequestID(xRequestID *string) *GetReplicationPolicyParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the get replication policy params
func (o *GetReplicationPolicyParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithID adds the id to the get replication policy params
func (o *GetReplicationPolicyParams) WithID(id int64) *GetReplicationPolicyParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the get replication policy params
func (o *GetReplicationPolicyParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *GetReplicationPolicyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
