// Code generated by go-swagger; DO NOT EDIT.

package replication

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// StopReplicationReader is a Reader for the StopReplication structure.
type StopReplicationReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *StopReplicationReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewStopReplicationOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewStopReplicationUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewStopReplicationForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewStopReplicationNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewStopReplicationInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewStopReplicationOK creates a StopReplicationOK with default headers values
func NewStopReplicationOK() *StopReplicationOK {
	return &StopReplicationOK{}
}

/*
StopReplicationOK describes a response with status code 200, with default header values.

Success
*/
type StopReplicationOK struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string
}

// IsSuccess returns true when this stop replication o k response has a 2xx status code
func (o *StopReplicationOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this stop replication o k response has a 3xx status code
func (o *StopReplicationOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this stop replication o k response has a 4xx status code
func (o *StopReplicationOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this stop replication o k response has a 5xx status code
func (o *StopReplicationOK) IsServerError() bool {
	return false
}

// IsCode returns true when this stop replication o k response a status code equal to that given
func (o *StopReplicationOK) IsCode(code int) bool {
	return code == 200
}

func (o *StopReplicationOK) Error() string {
	return fmt.Sprintf("[PUT /replication/executions/{id}][%d] stopReplicationOK ", 200)
}

func (o *StopReplicationOK) String() string {
	return fmt.Sprintf("[PUT /replication/executions/{id}][%d] stopReplicationOK ", 200)
}

func (o *StopReplicationOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	return nil
}

// NewStopReplicationUnauthorized creates a StopReplicationUnauthorized with default headers values
func NewStopReplicationUnauthorized() *StopReplicationUnauthorized {
	return &StopReplicationUnauthorized{}
}

/*
StopReplicationUnauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type StopReplicationUnauthorized struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this stop replication unauthorized response has a 2xx status code
func (o *StopReplicationUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this stop replication unauthorized response has a 3xx status code
func (o *StopReplicationUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this stop replication unauthorized response has a 4xx status code
func (o *StopReplicationUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this stop replication unauthorized response has a 5xx status code
func (o *StopReplicationUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this stop replication unauthorized response a status code equal to that given
func (o *StopReplicationUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *StopReplicationUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /replication/executions/{id}][%d] stopReplicationUnauthorized  %+v", 401, o.Payload)
}

func (o *StopReplicationUnauthorized) String() string {
	return fmt.Sprintf("[PUT /replication/executions/{id}][%d] stopReplicationUnauthorized  %+v", 401, o.Payload)
}

func (o *StopReplicationUnauthorized) GetPayload() *models.Errors {
	return o.Payload
}

func (o *StopReplicationUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewStopReplicationForbidden creates a StopReplicationForbidden with default headers values
func NewStopReplicationForbidden() *StopReplicationForbidden {
	return &StopReplicationForbidden{}
}

/*
StopReplicationForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type StopReplicationForbidden struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this stop replication forbidden response has a 2xx status code
func (o *StopReplicationForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this stop replication forbidden response has a 3xx status code
func (o *StopReplicationForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this stop replication forbidden response has a 4xx status code
func (o *StopReplicationForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this stop replication forbidden response has a 5xx status code
func (o *StopReplicationForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this stop replication forbidden response a status code equal to that given
func (o *StopReplicationForbidden) IsCode(code int) bool {
	return code == 403
}

func (o *StopReplicationForbidden) Error() string {
	return fmt.Sprintf("[PUT /replication/executions/{id}][%d] stopReplicationForbidden  %+v", 403, o.Payload)
}

func (o *StopReplicationForbidden) String() string {
	return fmt.Sprintf("[PUT /replication/executions/{id}][%d] stopReplicationForbidden  %+v", 403, o.Payload)
}

func (o *StopReplicationForbidden) GetPayload() *models.Errors {
	return o.Payload
}

func (o *StopReplicationForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewStopReplicationNotFound creates a StopReplicationNotFound with default headers values
func NewStopReplicationNotFound() *StopReplicationNotFound {
	return &StopReplicationNotFound{}
}

/*
StopReplicationNotFound describes a response with status code 404, with default header values.

Not found
*/
type StopReplicationNotFound struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this stop replication not found response has a 2xx status code
func (o *StopReplicationNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this stop replication not found response has a 3xx status code
func (o *StopReplicationNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this stop replication not found response has a 4xx status code
func (o *StopReplicationNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this stop replication not found response has a 5xx status code
func (o *StopReplicationNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this stop replication not found response a status code equal to that given
func (o *StopReplicationNotFound) IsCode(code int) bool {
	return code == 404
}

func (o *StopReplicationNotFound) Error() string {
	return fmt.Sprintf("[PUT /replication/executions/{id}][%d] stopReplicationNotFound  %+v", 404, o.Payload)
}

func (o *StopReplicationNotFound) String() string {
	return fmt.Sprintf("[PUT /replication/executions/{id}][%d] stopReplicationNotFound  %+v", 404, o.Payload)
}

func (o *StopReplicationNotFound) GetPayload() *models.Errors {
	return o.Payload
}

func (o *StopReplicationNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewStopReplicationInternalServerError creates a StopReplicationInternalServerError with default headers values
func NewStopReplicationInternalServerError() *StopReplicationInternalServerError {
	return &StopReplicationInternalServerError{}
}

/*
StopReplicationInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type StopReplicationInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this stop replication internal server error response has a 2xx status code
func (o *StopReplicationInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this stop replication internal server error response has a 3xx status code
func (o *StopReplicationInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this stop replication internal server error response has a 4xx status code
func (o *StopReplicationInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this stop replication internal server error response has a 5xx status code
func (o *StopReplicationInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this stop replication internal server error response a status code equal to that given
func (o *StopReplicationInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *StopReplicationInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /replication/executions/{id}][%d] stopReplicationInternalServerError  %+v", 500, o.Payload)
}

func (o *StopReplicationInternalServerError) String() string {
	return fmt.Sprintf("[PUT /replication/executions/{id}][%d] stopReplicationInternalServerError  %+v", 500, o.Payload)
}

func (o *StopReplicationInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *StopReplicationInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
