// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// ListAllRepositoriesReader is a Reader for the ListAllRepositories structure.
type ListAllRepositoriesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ListAllRepositoriesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewListAllRepositoriesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewListAllRepositoriesBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewListAllRepositoriesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewListAllRepositoriesOK creates a ListAllRepositoriesOK with default headers values
func NewListAllRepositoriesOK() *ListAllRepositoriesOK {
	return &ListAllRepositoriesOK{}
}

/*
ListAllRepositoriesOK describes a response with status code 200, with default header values.

Success
*/
type ListAllRepositoriesOK struct {

	/* Link refers to the previous page and next page
	 */
	Link string

	/* The total count of repositories
	 */
	XTotalCount int64

	Payload []*models.Repository
}

// IsSuccess returns true when this list all repositories o k response has a 2xx status code
func (o *ListAllRepositoriesOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this list all repositories o k response has a 3xx status code
func (o *ListAllRepositoriesOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this list all repositories o k response has a 4xx status code
func (o *ListAllRepositoriesOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this list all repositories o k response has a 5xx status code
func (o *ListAllRepositoriesOK) IsServerError() bool {
	return false
}

// IsCode returns true when this list all repositories o k response a status code equal to that given
func (o *ListAllRepositoriesOK) IsCode(code int) bool {
	return code == 200
}

func (o *ListAllRepositoriesOK) Error() string {
	return fmt.Sprintf("[GET /repositories][%d] listAllRepositoriesOK  %+v", 200, o.Payload)
}

func (o *ListAllRepositoriesOK) String() string {
	return fmt.Sprintf("[GET /repositories][%d] listAllRepositoriesOK  %+v", 200, o.Payload)
}

func (o *ListAllRepositoriesOK) GetPayload() []*models.Repository {
	return o.Payload
}

func (o *ListAllRepositoriesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Link
	hdrLink := response.GetHeader("Link")

	if hdrLink != "" {
		o.Link = hdrLink
	}

	// hydrates response header X-Total-Count
	hdrXTotalCount := response.GetHeader("X-Total-Count")

	if hdrXTotalCount != "" {
		valxTotalCount, err := swag.ConvertInt64(hdrXTotalCount)
		if err != nil {
			return errors.InvalidType("X-Total-Count", "header", "int64", hdrXTotalCount)
		}
		o.XTotalCount = valxTotalCount
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewListAllRepositoriesBadRequest creates a ListAllRepositoriesBadRequest with default headers values
func NewListAllRepositoriesBadRequest() *ListAllRepositoriesBadRequest {
	return &ListAllRepositoriesBadRequest{}
}

/*
ListAllRepositoriesBadRequest describes a response with status code 400, with default header values.

Bad request
*/
type ListAllRepositoriesBadRequest struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this list all repositories bad request response has a 2xx status code
func (o *ListAllRepositoriesBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this list all repositories bad request response has a 3xx status code
func (o *ListAllRepositoriesBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this list all repositories bad request response has a 4xx status code
func (o *ListAllRepositoriesBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this list all repositories bad request response has a 5xx status code
func (o *ListAllRepositoriesBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this list all repositories bad request response a status code equal to that given
func (o *ListAllRepositoriesBadRequest) IsCode(code int) bool {
	return code == 400
}

func (o *ListAllRepositoriesBadRequest) Error() string {
	return fmt.Sprintf("[GET /repositories][%d] listAllRepositoriesBadRequest  %+v", 400, o.Payload)
}

func (o *ListAllRepositoriesBadRequest) String() string {
	return fmt.Sprintf("[GET /repositories][%d] listAllRepositoriesBadRequest  %+v", 400, o.Payload)
}

func (o *ListAllRepositoriesBadRequest) GetPayload() *models.Errors {
	return o.Payload
}

func (o *ListAllRepositoriesBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewListAllRepositoriesInternalServerError creates a ListAllRepositoriesInternalServerError with default headers values
func NewListAllRepositoriesInternalServerError() *ListAllRepositoriesInternalServerError {
	return &ListAllRepositoriesInternalServerError{}
}

/*
ListAllRepositoriesInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type ListAllRepositoriesInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this list all repositories internal server error response has a 2xx status code
func (o *ListAllRepositoriesInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this list all repositories internal server error response has a 3xx status code
func (o *ListAllRepositoriesInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this list all repositories internal server error response has a 4xx status code
func (o *ListAllRepositoriesInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this list all repositories internal server error response has a 5xx status code
func (o *ListAllRepositoriesInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this list all repositories internal server error response a status code equal to that given
func (o *ListAllRepositoriesInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *ListAllRepositoriesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /repositories][%d] listAllRepositoriesInternalServerError  %+v", 500, o.Payload)
}

func (o *ListAllRepositoriesInternalServerError) String() string {
	return fmt.Sprintf("[GET /repositories][%d] listAllRepositoriesInternalServerError  %+v", 500, o.Payload)
}

func (o *ListAllRepositoriesInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *ListAllRepositoriesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
