// Code generated by go-swagger; DO NOT EDIT.

package retention

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// CreateRetentionReader is a Reader for the CreateRetention structure.
type CreateRetentionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateRetentionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewCreateRetentionCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewCreateRetentionBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewCreateRetentionUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewCreateRetentionForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewCreateRetentionInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewCreateRetentionCreated creates a CreateRetentionCreated with default headers values
func NewCreateRetentionCreated() *CreateRetentionCreated {
	return &CreateRetentionCreated{}
}

/*
CreateRetentionCreated describes a response with status code 201, with default header values.

Created
*/
type CreateRetentionCreated struct {

	/* The location of the resource
	 */
	Location string

	/* The ID of the corresponding request for the response
	 */
	XRequestID string
}

// IsSuccess returns true when this create retention created response has a 2xx status code
func (o *CreateRetentionCreated) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this create retention created response has a 3xx status code
func (o *CreateRetentionCreated) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create retention created response has a 4xx status code
func (o *CreateRetentionCreated) IsClientError() bool {
	return false
}

// IsServerError returns true when this create retention created response has a 5xx status code
func (o *CreateRetentionCreated) IsServerError() bool {
	return false
}

// IsCode returns true when this create retention created response a status code equal to that given
func (o *CreateRetentionCreated) IsCode(code int) bool {
	return code == 201
}

func (o *CreateRetentionCreated) Error() string {
	return fmt.Sprintf("[POST /retentions][%d] createRetentionCreated ", 201)
}

func (o *CreateRetentionCreated) String() string {
	return fmt.Sprintf("[POST /retentions][%d] createRetentionCreated ", 201)
}

func (o *CreateRetentionCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Location
	hdrLocation := response.GetHeader("Location")

	if hdrLocation != "" {
		o.Location = hdrLocation
	}

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	return nil
}

// NewCreateRetentionBadRequest creates a CreateRetentionBadRequest with default headers values
func NewCreateRetentionBadRequest() *CreateRetentionBadRequest {
	return &CreateRetentionBadRequest{}
}

/*
CreateRetentionBadRequest describes a response with status code 400, with default header values.

Bad request
*/
type CreateRetentionBadRequest struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create retention bad request response has a 2xx status code
func (o *CreateRetentionBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create retention bad request response has a 3xx status code
func (o *CreateRetentionBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create retention bad request response has a 4xx status code
func (o *CreateRetentionBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this create retention bad request response has a 5xx status code
func (o *CreateRetentionBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this create retention bad request response a status code equal to that given
func (o *CreateRetentionBadRequest) IsCode(code int) bool {
	return code == 400
}

func (o *CreateRetentionBadRequest) Error() string {
	return fmt.Sprintf("[POST /retentions][%d] createRetentionBadRequest  %+v", 400, o.Payload)
}

func (o *CreateRetentionBadRequest) String() string {
	return fmt.Sprintf("[POST /retentions][%d] createRetentionBadRequest  %+v", 400, o.Payload)
}

func (o *CreateRetentionBadRequest) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateRetentionBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateRetentionUnauthorized creates a CreateRetentionUnauthorized with default headers values
func NewCreateRetentionUnauthorized() *CreateRetentionUnauthorized {
	return &CreateRetentionUnauthorized{}
}

/*
CreateRetentionUnauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type CreateRetentionUnauthorized struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create retention unauthorized response has a 2xx status code
func (o *CreateRetentionUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create retention unauthorized response has a 3xx status code
func (o *CreateRetentionUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create retention unauthorized response has a 4xx status code
func (o *CreateRetentionUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this create retention unauthorized response has a 5xx status code
func (o *CreateRetentionUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this create retention unauthorized response a status code equal to that given
func (o *CreateRetentionUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *CreateRetentionUnauthorized) Error() string {
	return fmt.Sprintf("[POST /retentions][%d] createRetentionUnauthorized  %+v", 401, o.Payload)
}

func (o *CreateRetentionUnauthorized) String() string {
	return fmt.Sprintf("[POST /retentions][%d] createRetentionUnauthorized  %+v", 401, o.Payload)
}

func (o *CreateRetentionUnauthorized) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateRetentionUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateRetentionForbidden creates a CreateRetentionForbidden with default headers values
func NewCreateRetentionForbidden() *CreateRetentionForbidden {
	return &CreateRetentionForbidden{}
}

/*
CreateRetentionForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type CreateRetentionForbidden struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create retention forbidden response has a 2xx status code
func (o *CreateRetentionForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create retention forbidden response has a 3xx status code
func (o *CreateRetentionForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create retention forbidden response has a 4xx status code
func (o *CreateRetentionForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this create retention forbidden response has a 5xx status code
func (o *CreateRetentionForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this create retention forbidden response a status code equal to that given
func (o *CreateRetentionForbidden) IsCode(code int) bool {
	return code == 403
}

func (o *CreateRetentionForbidden) Error() string {
	return fmt.Sprintf("[POST /retentions][%d] createRetentionForbidden  %+v", 403, o.Payload)
}

func (o *CreateRetentionForbidden) String() string {
	return fmt.Sprintf("[POST /retentions][%d] createRetentionForbidden  %+v", 403, o.Payload)
}

func (o *CreateRetentionForbidden) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateRetentionForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateRetentionInternalServerError creates a CreateRetentionInternalServerError with default headers values
func NewCreateRetentionInternalServerError() *CreateRetentionInternalServerError {
	return &CreateRetentionInternalServerError{}
}

/*
CreateRetentionInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type CreateRetentionInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this create retention internal server error response has a 2xx status code
func (o *CreateRetentionInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create retention internal server error response has a 3xx status code
func (o *CreateRetentionInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create retention internal server error response has a 4xx status code
func (o *CreateRetentionInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this create retention internal server error response has a 5xx status code
func (o *CreateRetentionInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this create retention internal server error response a status code equal to that given
func (o *CreateRetentionInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *CreateRetentionInternalServerError) Error() string {
	return fmt.Sprintf("[POST /retentions][%d] createRetentionInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateRetentionInternalServerError) String() string {
	return fmt.Sprintf("[POST /retentions][%d] createRetentionInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateRetentionInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *CreateRetentionInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
