// Code generated by go-swagger; DO NOT EDIT.

package retention

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

//go:generate mockery -name API -inpkg

// API is the interface of the retention client
type API interface {
	/*
	   CreateRetention creates retention policy

	   Create Retention Policy, you can reference metadatas API for the policy model. You can check project metadatas to find whether a retention policy is already binded. This method should only be called when no retention policy binded to project yet.*/
	CreateRetention(ctx context.Context, params *CreateRetentionParams) (*CreateRetentionCreated, error)
	/*
	   DeleteRetention deletes retention policy

	   Delete Retention Policy, you can reference metadatas API for the policy model. You can check project metadatas to find whether a retention policy is already binded. This method should only be called when retention policy has already binded to project.*/
	DeleteRetention(ctx context.Context, params *DeleteRetentionParams) (*DeleteRetentionOK, error)
	/*
	   GetRentenitionMetadata gets retention metadatas

	   Get Retention Metadatas.*/
	GetRentenitionMetadata(ctx context.Context, params *GetRentenitionMetadataParams) (*GetRentenitionMetadataOK, error)
	/*
	   GetRetention gets retention policy

	   Get Retention Policy.*/
	GetRetention(ctx context.Context, params *GetRetentionParams) (*GetRetentionOK, error)
	/*
	   GetRetentionTaskLog gets retention job task log

	   Get Retention job task log, tags ratain or deletion detail will be shown in a table.*/
	GetRetentionTaskLog(ctx context.Context, params *GetRetentionTaskLogParams) (*GetRetentionTaskLogOK, error)
	/*
	   ListRetentionExecutions gets retention executions

	   Get Retention executions, execution status may be delayed before job service schedule it up.*/
	ListRetentionExecutions(ctx context.Context, params *ListRetentionExecutionsParams) (*ListRetentionExecutionsOK, error)
	/*
	   ListRetentionTasks gets retention tasks

	   Get Retention tasks, each repository as a task.*/
	ListRetentionTasks(ctx context.Context, params *ListRetentionTasksParams) (*ListRetentionTasksOK, error)
	/*
	   OperateRetentionExecution stops a retention execution

	   Stop a Retention execution, only support "stop" action now.*/
	OperateRetentionExecution(ctx context.Context, params *OperateRetentionExecutionParams) (*OperateRetentionExecutionOK, error)
	/*
	   TriggerRetentionExecution triggers a retention execution

	   Trigger a Retention Execution, if dry_run is True, nothing would be deleted actually.*/
	TriggerRetentionExecution(ctx context.Context, params *TriggerRetentionExecutionParams) (*TriggerRetentionExecutionOK, *TriggerRetentionExecutionCreated, error)
	/*
	   UpdateRetention updates retention policy

	   Update Retention Policy, you can reference metadatas API for the policy model. You can check project metadatas to find whether a retention policy is already binded. This method should only be called when retention policy has already binded to project.*/
	UpdateRetention(ctx context.Context, params *UpdateRetentionParams) (*UpdateRetentionOK, error)
}

// New creates a new retention API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry, authInfo runtime.ClientAuthInfoWriter) *Client {
	return &Client{
		transport: transport,
		formats:   formats,
		authInfo:  authInfo,
	}
}

/*
Client for retention API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
	authInfo  runtime.ClientAuthInfoWriter
}

/*
CreateRetention creates retention policy

Create Retention Policy, you can reference metadatas API for the policy model. You can check project metadatas to find whether a retention policy is already binded. This method should only be called when no retention policy binded to project yet.
*/
func (a *Client) CreateRetention(ctx context.Context, params *CreateRetentionParams) (*CreateRetentionCreated, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "createRetention",
		Method:             "POST",
		PathPattern:        "/retentions",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &CreateRetentionReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*CreateRetentionCreated), nil

}

/*
DeleteRetention deletes retention policy

Delete Retention Policy, you can reference metadatas API for the policy model. You can check project metadatas to find whether a retention policy is already binded. This method should only be called when retention policy has already binded to project.
*/
func (a *Client) DeleteRetention(ctx context.Context, params *DeleteRetentionParams) (*DeleteRetentionOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteRetention",
		Method:             "DELETE",
		PathPattern:        "/retentions/{id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &DeleteRetentionReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*DeleteRetentionOK), nil

}

/*
GetRentenitionMetadata gets retention metadatas

Get Retention Metadatas.
*/
func (a *Client) GetRentenitionMetadata(ctx context.Context, params *GetRentenitionMetadataParams) (*GetRentenitionMetadataOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getRentenitionMetadata",
		Method:             "GET",
		PathPattern:        "/retentions/metadatas",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetRentenitionMetadataReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetRentenitionMetadataOK), nil

}

/*
GetRetention gets retention policy

Get Retention Policy.
*/
func (a *Client) GetRetention(ctx context.Context, params *GetRetentionParams) (*GetRetentionOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getRetention",
		Method:             "GET",
		PathPattern:        "/retentions/{id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetRetentionReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetRetentionOK), nil

}

/*
GetRetentionTaskLog gets retention job task log

Get Retention job task log, tags ratain or deletion detail will be shown in a table.
*/
func (a *Client) GetRetentionTaskLog(ctx context.Context, params *GetRetentionTaskLogParams) (*GetRetentionTaskLogOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getRetentionTaskLog",
		Method:             "GET",
		PathPattern:        "/retentions/{id}/executions/{eid}/tasks/{tid}",
		ProducesMediaTypes: []string{"text/plain"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetRetentionTaskLogReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetRetentionTaskLogOK), nil

}

/*
ListRetentionExecutions gets retention executions

Get Retention executions, execution status may be delayed before job service schedule it up.
*/
func (a *Client) ListRetentionExecutions(ctx context.Context, params *ListRetentionExecutionsParams) (*ListRetentionExecutionsOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "listRetentionExecutions",
		Method:             "GET",
		PathPattern:        "/retentions/{id}/executions",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ListRetentionExecutionsReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*ListRetentionExecutionsOK), nil

}

/*
ListRetentionTasks gets retention tasks

Get Retention tasks, each repository as a task.
*/
func (a *Client) ListRetentionTasks(ctx context.Context, params *ListRetentionTasksParams) (*ListRetentionTasksOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "listRetentionTasks",
		Method:             "GET",
		PathPattern:        "/retentions/{id}/executions/{eid}/tasks",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ListRetentionTasksReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*ListRetentionTasksOK), nil

}

/*
OperateRetentionExecution stops a retention execution

Stop a Retention execution, only support "stop" action now.
*/
func (a *Client) OperateRetentionExecution(ctx context.Context, params *OperateRetentionExecutionParams) (*OperateRetentionExecutionOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "operateRetentionExecution",
		Method:             "PATCH",
		PathPattern:        "/retentions/{id}/executions/{eid}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &OperateRetentionExecutionReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*OperateRetentionExecutionOK), nil

}

/*
TriggerRetentionExecution triggers a retention execution

Trigger a Retention Execution, if dry_run is True, nothing would be deleted actually.
*/
func (a *Client) TriggerRetentionExecution(ctx context.Context, params *TriggerRetentionExecutionParams) (*TriggerRetentionExecutionOK, *TriggerRetentionExecutionCreated, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "triggerRetentionExecution",
		Method:             "POST",
		PathPattern:        "/retentions/{id}/executions",
		ProducesMediaTypes: []string{"text/plain"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &TriggerRetentionExecutionReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, nil, err
	}
	switch value := result.(type) {
	case *TriggerRetentionExecutionOK:
		return value, nil, nil
	case *TriggerRetentionExecutionCreated:
		return nil, value, nil
	}
	return nil, nil, nil

}

/*
UpdateRetention updates retention policy

Update Retention Policy, you can reference metadatas API for the policy model. You can check project metadatas to find whether a retention policy is already binded. This method should only be called when retention policy has already binded to project.
*/
func (a *Client) UpdateRetention(ctx context.Context, params *UpdateRetentionParams) (*UpdateRetentionOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "updateRetention",
		Method:             "PUT",
		PathPattern:        "/retentions/{id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &UpdateRetentionReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*UpdateRetentionOK), nil

}
