// Code generated by go-swagger; DO NOT EDIT.

package robot

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDeleteRobotParams creates a new DeleteRobotParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteRobotParams() *DeleteRobotParams {
	return &DeleteRobotParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteRobotParamsWithTimeout creates a new DeleteRobotParams object
// with the ability to set a timeout on a request.
func NewDeleteRobotParamsWithTimeout(timeout time.Duration) *DeleteRobotParams {
	return &DeleteRobotParams{
		timeout: timeout,
	}
}

// NewDeleteRobotParamsWithContext creates a new DeleteRobotParams object
// with the ability to set a context for a request.
func NewDeleteRobotParamsWithContext(ctx context.Context) *DeleteRobotParams {
	return &DeleteRobotParams{
		Context: ctx,
	}
}

// NewDeleteRobotParamsWithHTTPClient creates a new DeleteRobotParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteRobotParamsWithHTTPClient(client *http.Client) *DeleteRobotParams {
	return &DeleteRobotParams{
		HTTPClient: client,
	}
}

/*
DeleteRobotParams contains all the parameters to send to the API endpoint

	for the delete robot operation.

	Typically these are written to a http.Request.
*/
type DeleteRobotParams struct {

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* RobotID.

	   Robot ID
	*/
	RobotID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete robot params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteRobotParams) WithDefaults() *DeleteRobotParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete robot params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteRobotParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete robot params
func (o *DeleteRobotParams) WithTimeout(timeout time.Duration) *DeleteRobotParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete robot params
func (o *DeleteRobotParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete robot params
func (o *DeleteRobotParams) WithContext(ctx context.Context) *DeleteRobotParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete robot params
func (o *DeleteRobotParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete robot params
func (o *DeleteRobotParams) WithHTTPClient(client *http.Client) *DeleteRobotParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete robot params
func (o *DeleteRobotParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXRequestID adds the xRequestID to the delete robot params
func (o *DeleteRobotParams) WithXRequestID(xRequestID *string) *DeleteRobotParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the delete robot params
func (o *DeleteRobotParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithRobotID adds the robotID to the delete robot params
func (o *DeleteRobotParams) WithRobotID(robotID int64) *DeleteRobotParams {
	o.SetRobotID(robotID)
	return o
}

// SetRobotID adds the robotId to the delete robot params
func (o *DeleteRobotParams) SetRobotID(robotID int64) {
	o.RobotID = robotID
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteRobotParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param robot_id
	if err := r.SetPathParam("robot_id", swag.FormatInt64(o.RobotID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
