// Code generated by go-swagger; DO NOT EDIT.

package scan

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

//go:generate mockery -name API -inpkg

// API is the interface of the scan client
type API interface {
	/*
	   GetReportLog gets the log of the scan report

	   Get the log of the scan report*/
	GetReportLog(ctx context.Context, params *GetReportLogParams) (*GetReportLogOK, error)
	/*
	   ScanArtifact scans the artifact

	   Scan the specified artifact*/
	ScanArtifact(ctx context.Context, params *ScanArtifactParams) (*ScanArtifactAccepted, error)
	/*
	   StopScanArtifact cancellings a scan job for a particular artifact

	   Cancelling a scan job for a particular artifact*/
	StopScanArtifact(ctx context.Context, params *StopScanArtifactParams) (*StopScanArtifactAccepted, error)
}

// New creates a new scan API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry, authInfo runtime.ClientAuthInfoWriter) *Client {
	return &Client{
		transport: transport,
		formats:   formats,
		authInfo:  authInfo,
	}
}

/*
Client for scan API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
	authInfo  runtime.ClientAuthInfoWriter
}

/*
GetReportLog gets the log of the scan report

Get the log of the scan report
*/
func (a *Client) GetReportLog(ctx context.Context, params *GetReportLogParams) (*GetReportLogOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getReportLog",
		Method:             "GET",
		PathPattern:        "/projects/{project_name}/repositories/{repository_name}/artifacts/{reference}/scan/{report_id}/log",
		ProducesMediaTypes: []string{"text/plain"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetReportLogReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetReportLogOK), nil

}

/*
ScanArtifact scans the artifact

Scan the specified artifact
*/
func (a *Client) ScanArtifact(ctx context.Context, params *ScanArtifactParams) (*ScanArtifactAccepted, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "scanArtifact",
		Method:             "POST",
		PathPattern:        "/projects/{project_name}/repositories/{repository_name}/artifacts/{reference}/scan",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ScanArtifactReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*ScanArtifactAccepted), nil

}

/*
StopScanArtifact cancellings a scan job for a particular artifact

Cancelling a scan job for a particular artifact
*/
func (a *Client) StopScanArtifact(ctx context.Context, params *StopScanArtifactParams) (*StopScanArtifactAccepted, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "stopScanArtifact",
		Method:             "POST",
		PathPattern:        "/projects/{project_name}/repositories/{repository_name}/artifacts/{reference}/scan/stop",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &StopScanArtifactReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*StopScanArtifactAccepted), nil

}
