// Code generated by go-swagger; DO NOT EDIT.

package system_cve_allowlist

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// GetSystemCVEAllowlistReader is a Reader for the GetSystemCVEAllowlist structure.
type GetSystemCVEAllowlistReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetSystemCVEAllowlistReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetSystemCVEAllowlistOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetSystemCVEAllowlistUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetSystemCVEAllowlistInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetSystemCVEAllowlistOK creates a GetSystemCVEAllowlistOK with default headers values
func NewGetSystemCVEAllowlistOK() *GetSystemCVEAllowlistOK {
	return &GetSystemCVEAllowlistOK{}
}

/*
GetSystemCVEAllowlistOK describes a response with status code 200, with default header values.

Successfully retrieved the CVE allowlist.
*/
type GetSystemCVEAllowlistOK struct {
	Payload *models.CVEAllowlist
}

// IsSuccess returns true when this get system Cve allowlist o k response has a 2xx status code
func (o *GetSystemCVEAllowlistOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get system Cve allowlist o k response has a 3xx status code
func (o *GetSystemCVEAllowlistOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get system Cve allowlist o k response has a 4xx status code
func (o *GetSystemCVEAllowlistOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get system Cve allowlist o k response has a 5xx status code
func (o *GetSystemCVEAllowlistOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get system Cve allowlist o k response a status code equal to that given
func (o *GetSystemCVEAllowlistOK) IsCode(code int) bool {
	return code == 200
}

func (o *GetSystemCVEAllowlistOK) Error() string {
	return fmt.Sprintf("[GET /system/CVEAllowlist][%d] getSystemCveAllowlistOK  %+v", 200, o.Payload)
}

func (o *GetSystemCVEAllowlistOK) String() string {
	return fmt.Sprintf("[GET /system/CVEAllowlist][%d] getSystemCveAllowlistOK  %+v", 200, o.Payload)
}

func (o *GetSystemCVEAllowlistOK) GetPayload() *models.CVEAllowlist {
	return o.Payload
}

func (o *GetSystemCVEAllowlistOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.CVEAllowlist)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSystemCVEAllowlistUnauthorized creates a GetSystemCVEAllowlistUnauthorized with default headers values
func NewGetSystemCVEAllowlistUnauthorized() *GetSystemCVEAllowlistUnauthorized {
	return &GetSystemCVEAllowlistUnauthorized{}
}

/*
GetSystemCVEAllowlistUnauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type GetSystemCVEAllowlistUnauthorized struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get system Cve allowlist unauthorized response has a 2xx status code
func (o *GetSystemCVEAllowlistUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get system Cve allowlist unauthorized response has a 3xx status code
func (o *GetSystemCVEAllowlistUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get system Cve allowlist unauthorized response has a 4xx status code
func (o *GetSystemCVEAllowlistUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get system Cve allowlist unauthorized response has a 5xx status code
func (o *GetSystemCVEAllowlistUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get system Cve allowlist unauthorized response a status code equal to that given
func (o *GetSystemCVEAllowlistUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *GetSystemCVEAllowlistUnauthorized) Error() string {
	return fmt.Sprintf("[GET /system/CVEAllowlist][%d] getSystemCveAllowlistUnauthorized  %+v", 401, o.Payload)
}

func (o *GetSystemCVEAllowlistUnauthorized) String() string {
	return fmt.Sprintf("[GET /system/CVEAllowlist][%d] getSystemCveAllowlistUnauthorized  %+v", 401, o.Payload)
}

func (o *GetSystemCVEAllowlistUnauthorized) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetSystemCVEAllowlistUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSystemCVEAllowlistInternalServerError creates a GetSystemCVEAllowlistInternalServerError with default headers values
func NewGetSystemCVEAllowlistInternalServerError() *GetSystemCVEAllowlistInternalServerError {
	return &GetSystemCVEAllowlistInternalServerError{}
}

/*
GetSystemCVEAllowlistInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type GetSystemCVEAllowlistInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this get system Cve allowlist internal server error response has a 2xx status code
func (o *GetSystemCVEAllowlistInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get system Cve allowlist internal server error response has a 3xx status code
func (o *GetSystemCVEAllowlistInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get system Cve allowlist internal server error response has a 4xx status code
func (o *GetSystemCVEAllowlistInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get system Cve allowlist internal server error response has a 5xx status code
func (o *GetSystemCVEAllowlistInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get system Cve allowlist internal server error response a status code equal to that given
func (o *GetSystemCVEAllowlistInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *GetSystemCVEAllowlistInternalServerError) Error() string {
	return fmt.Sprintf("[GET /system/CVEAllowlist][%d] getSystemCveAllowlistInternalServerError  %+v", 500, o.Payload)
}

func (o *GetSystemCVEAllowlistInternalServerError) String() string {
	return fmt.Sprintf("[GET /system/CVEAllowlist][%d] getSystemCveAllowlistInternalServerError  %+v", 500, o.Payload)
}

func (o *GetSystemCVEAllowlistInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *GetSystemCVEAllowlistInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
