// Code generated by go-swagger; DO NOT EDIT.

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// GetCurrentUserPermissionsReader is a Reader for the GetCurrentUserPermissions structure.
type GetCurrentUserPermissionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCurrentUserPermissionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCurrentUserPermissionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetCurrentUserPermissionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetCurrentUserPermissionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetCurrentUserPermissionsOK creates a GetCurrentUserPermissionsOK with default headers values
func NewGetCurrentUserPermissionsOK() *GetCurrentUserPermissionsOK {
	return &GetCurrentUserPermissionsOK{}
}

/*
GetCurrentUserPermissionsOK describes a response with status code 200, with default header values.

Get current user permission successfully.
*/
type GetCurrentUserPermissionsOK struct {
	Payload []*models.Permission
}

// IsSuccess returns true when this get current user permissions o k response has a 2xx status code
func (o *GetCurrentUserPermissionsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get current user permissions o k response has a 3xx status code
func (o *GetCurrentUserPermissionsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get current user permissions o k response has a 4xx status code
func (o *GetCurrentUserPermissionsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get current user permissions o k response has a 5xx status code
func (o *GetCurrentUserPermissionsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get current user permissions o k response a status code equal to that given
func (o *GetCurrentUserPermissionsOK) IsCode(code int) bool {
	return code == 200
}

func (o *GetCurrentUserPermissionsOK) Error() string {
	return fmt.Sprintf("[GET /users/current/permissions][%d] getCurrentUserPermissionsOK  %+v", 200, o.Payload)
}

func (o *GetCurrentUserPermissionsOK) String() string {
	return fmt.Sprintf("[GET /users/current/permissions][%d] getCurrentUserPermissionsOK  %+v", 200, o.Payload)
}

func (o *GetCurrentUserPermissionsOK) GetPayload() []*models.Permission {
	return o.Payload
}

func (o *GetCurrentUserPermissionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCurrentUserPermissionsUnauthorized creates a GetCurrentUserPermissionsUnauthorized with default headers values
func NewGetCurrentUserPermissionsUnauthorized() *GetCurrentUserPermissionsUnauthorized {
	return &GetCurrentUserPermissionsUnauthorized{}
}

/*
GetCurrentUserPermissionsUnauthorized describes a response with status code 401, with default header values.

User need to log in first.
*/
type GetCurrentUserPermissionsUnauthorized struct {
}

// IsSuccess returns true when this get current user permissions unauthorized response has a 2xx status code
func (o *GetCurrentUserPermissionsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get current user permissions unauthorized response has a 3xx status code
func (o *GetCurrentUserPermissionsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get current user permissions unauthorized response has a 4xx status code
func (o *GetCurrentUserPermissionsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get current user permissions unauthorized response has a 5xx status code
func (o *GetCurrentUserPermissionsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get current user permissions unauthorized response a status code equal to that given
func (o *GetCurrentUserPermissionsUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *GetCurrentUserPermissionsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /users/current/permissions][%d] getCurrentUserPermissionsUnauthorized ", 401)
}

func (o *GetCurrentUserPermissionsUnauthorized) String() string {
	return fmt.Sprintf("[GET /users/current/permissions][%d] getCurrentUserPermissionsUnauthorized ", 401)
}

func (o *GetCurrentUserPermissionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewGetCurrentUserPermissionsInternalServerError creates a GetCurrentUserPermissionsInternalServerError with default headers values
func NewGetCurrentUserPermissionsInternalServerError() *GetCurrentUserPermissionsInternalServerError {
	return &GetCurrentUserPermissionsInternalServerError{}
}

/*
GetCurrentUserPermissionsInternalServerError describes a response with status code 500, with default header values.

Internal errors.
*/
type GetCurrentUserPermissionsInternalServerError struct {
}

// IsSuccess returns true when this get current user permissions internal server error response has a 2xx status code
func (o *GetCurrentUserPermissionsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get current user permissions internal server error response has a 3xx status code
func (o *GetCurrentUserPermissionsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get current user permissions internal server error response has a 4xx status code
func (o *GetCurrentUserPermissionsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get current user permissions internal server error response has a 5xx status code
func (o *GetCurrentUserPermissionsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get current user permissions internal server error response a status code equal to that given
func (o *GetCurrentUserPermissionsInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *GetCurrentUserPermissionsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /users/current/permissions][%d] getCurrentUserPermissionsInternalServerError ", 500)
}

func (o *GetCurrentUserPermissionsInternalServerError) String() string {
	return fmt.Sprintf("[GET /users/current/permissions][%d] getCurrentUserPermissionsInternalServerError ", 500)
}

func (o *GetCurrentUserPermissionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
