// Code generated by go-swagger; DO NOT EDIT.

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSearchUsersParams creates a new SearchUsersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSearchUsersParams() *SearchUsersParams {
	return &SearchUsersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSearchUsersParamsWithTimeout creates a new SearchUsersParams object
// with the ability to set a timeout on a request.
func NewSearchUsersParamsWithTimeout(timeout time.Duration) *SearchUsersParams {
	return &SearchUsersParams{
		timeout: timeout,
	}
}

// NewSearchUsersParamsWithContext creates a new SearchUsersParams object
// with the ability to set a context for a request.
func NewSearchUsersParamsWithContext(ctx context.Context) *SearchUsersParams {
	return &SearchUsersParams{
		Context: ctx,
	}
}

// NewSearchUsersParamsWithHTTPClient creates a new SearchUsersParams object
// with the ability to set a custom HTTPClient for a request.
func NewSearchUsersParamsWithHTTPClient(client *http.Client) *SearchUsersParams {
	return &SearchUsersParams{
		HTTPClient: client,
	}
}

/*
SearchUsersParams contains all the parameters to send to the API endpoint

	for the search users operation.

	Typically these are written to a http.Request.
*/
type SearchUsersParams struct {

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* Page.

	   The page number

	   Format: int64
	   Default: 1
	*/
	Page *int64

	/* PageSize.

	   The size of per page

	   Format: int64
	   Default: 10
	*/
	PageSize *int64

	/* Username.

	   Username for filtering results.
	*/
	Username string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the search users params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SearchUsersParams) WithDefaults() *SearchUsersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the search users params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SearchUsersParams) SetDefaults() {
	var (
		pageDefault = int64(1)

		pageSizeDefault = int64(10)
	)

	val := SearchUsersParams{
		Page:     &pageDefault,
		PageSize: &pageSizeDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the search users params
func (o *SearchUsersParams) WithTimeout(timeout time.Duration) *SearchUsersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the search users params
func (o *SearchUsersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the search users params
func (o *SearchUsersParams) WithContext(ctx context.Context) *SearchUsersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the search users params
func (o *SearchUsersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the search users params
func (o *SearchUsersParams) WithHTTPClient(client *http.Client) *SearchUsersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the search users params
func (o *SearchUsersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXRequestID adds the xRequestID to the search users params
func (o *SearchUsersParams) WithXRequestID(xRequestID *string) *SearchUsersParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the search users params
func (o *SearchUsersParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithPage adds the page to the search users params
func (o *SearchUsersParams) WithPage(page *int64) *SearchUsersParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the search users params
func (o *SearchUsersParams) SetPage(page *int64) {
	o.Page = page
}

// WithPageSize adds the pageSize to the search users params
func (o *SearchUsersParams) WithPageSize(pageSize *int64) *SearchUsersParams {
	o.SetPageSize(pageSize)
	return o
}

// SetPageSize adds the pageSize to the search users params
func (o *SearchUsersParams) SetPageSize(pageSize *int64) {
	o.PageSize = pageSize
}

// WithUsername adds the username to the search users params
func (o *SearchUsersParams) WithUsername(username string) *SearchUsersParams {
	o.SetUsername(username)
	return o
}

// SetUsername adds the username to the search users params
func (o *SearchUsersParams) SetUsername(username string) {
	o.Username = username
}

// WriteToRequest writes these params to a swagger request
func (o *SearchUsersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	if o.PageSize != nil {

		// query param page_size
		var qrPageSize int64

		if o.PageSize != nil {
			qrPageSize = *o.PageSize
		}
		qPageSize := swag.FormatInt64(qrPageSize)
		if qPageSize != "" {

			if err := r.SetQueryParam("page_size", qPageSize); err != nil {
				return err
			}
		}
	}

	// query param username
	qrUsername := o.Username
	qUsername := qrUsername
	if qUsername != "" {

		if err := r.SetQueryParam("username", qUsername); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
