// Code generated by go-swagger; DO NOT EDIT.

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/goharbor/go-client/pkg/sdk/v2.0/models"
)

// SearchUsersReader is a Reader for the SearchUsers structure.
type SearchUsersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SearchUsersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewSearchUsersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewSearchUsersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewSearchUsersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewSearchUsersOK creates a SearchUsersOK with default headers values
func NewSearchUsersOK() *SearchUsersOK {
	return &SearchUsersOK{}
}

/*
SearchUsersOK describes a response with status code 200, with default header values.

Search users by username successfully.
*/
type SearchUsersOK struct {

	/* Link to previous page and next page
	 */
	Link string

	/* The total count of available items
	 */
	XTotalCount int64

	Payload []*models.UserSearchRespItem
}

// IsSuccess returns true when this search users o k response has a 2xx status code
func (o *SearchUsersOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this search users o k response has a 3xx status code
func (o *SearchUsersOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this search users o k response has a 4xx status code
func (o *SearchUsersOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this search users o k response has a 5xx status code
func (o *SearchUsersOK) IsServerError() bool {
	return false
}

// IsCode returns true when this search users o k response a status code equal to that given
func (o *SearchUsersOK) IsCode(code int) bool {
	return code == 200
}

func (o *SearchUsersOK) Error() string {
	return fmt.Sprintf("[GET /users/search][%d] searchUsersOK  %+v", 200, o.Payload)
}

func (o *SearchUsersOK) String() string {
	return fmt.Sprintf("[GET /users/search][%d] searchUsersOK  %+v", 200, o.Payload)
}

func (o *SearchUsersOK) GetPayload() []*models.UserSearchRespItem {
	return o.Payload
}

func (o *SearchUsersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Link
	hdrLink := response.GetHeader("Link")

	if hdrLink != "" {
		o.Link = hdrLink
	}

	// hydrates response header X-Total-Count
	hdrXTotalCount := response.GetHeader("X-Total-Count")

	if hdrXTotalCount != "" {
		valxTotalCount, err := swag.ConvertInt64(hdrXTotalCount)
		if err != nil {
			return errors.InvalidType("X-Total-Count", "header", "int64", hdrXTotalCount)
		}
		o.XTotalCount = valxTotalCount
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSearchUsersUnauthorized creates a SearchUsersUnauthorized with default headers values
func NewSearchUsersUnauthorized() *SearchUsersUnauthorized {
	return &SearchUsersUnauthorized{}
}

/*
SearchUsersUnauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type SearchUsersUnauthorized struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this search users unauthorized response has a 2xx status code
func (o *SearchUsersUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this search users unauthorized response has a 3xx status code
func (o *SearchUsersUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this search users unauthorized response has a 4xx status code
func (o *SearchUsersUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this search users unauthorized response has a 5xx status code
func (o *SearchUsersUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this search users unauthorized response a status code equal to that given
func (o *SearchUsersUnauthorized) IsCode(code int) bool {
	return code == 401
}

func (o *SearchUsersUnauthorized) Error() string {
	return fmt.Sprintf("[GET /users/search][%d] searchUsersUnauthorized  %+v", 401, o.Payload)
}

func (o *SearchUsersUnauthorized) String() string {
	return fmt.Sprintf("[GET /users/search][%d] searchUsersUnauthorized  %+v", 401, o.Payload)
}

func (o *SearchUsersUnauthorized) GetPayload() *models.Errors {
	return o.Payload
}

func (o *SearchUsersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSearchUsersInternalServerError creates a SearchUsersInternalServerError with default headers values
func NewSearchUsersInternalServerError() *SearchUsersInternalServerError {
	return &SearchUsersInternalServerError{}
}

/*
SearchUsersInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type SearchUsersInternalServerError struct {

	/* The ID of the corresponding request for the response
	 */
	XRequestID string

	Payload *models.Errors
}

// IsSuccess returns true when this search users internal server error response has a 2xx status code
func (o *SearchUsersInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this search users internal server error response has a 3xx status code
func (o *SearchUsersInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this search users internal server error response has a 4xx status code
func (o *SearchUsersInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this search users internal server error response has a 5xx status code
func (o *SearchUsersInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this search users internal server error response a status code equal to that given
func (o *SearchUsersInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *SearchUsersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /users/search][%d] searchUsersInternalServerError  %+v", 500, o.Payload)
}

func (o *SearchUsersInternalServerError) String() string {
	return fmt.Sprintf("[GET /users/search][%d] searchUsersInternalServerError  %+v", 500, o.Payload)
}

func (o *SearchUsersInternalServerError) GetPayload() *models.Errors {
	return o.Payload
}

func (o *SearchUsersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-Request-Id
	hdrXRequestID := response.GetHeader("X-Request-Id")

	if hdrXRequestID != "" {
		o.XRequestID = hdrXRequestID
	}

	o.Payload = new(models.Errors)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
