// Code generated by go-swagger; DO NOT EDIT.

package usergroup

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

//go:generate mockery -name API -inpkg

// API is the interface of the usergroup client
type API interface {
	/*
	   CreateUserGroup creates user group

	   Create user group information*/
	CreateUserGroup(ctx context.Context, params *CreateUserGroupParams) (*CreateUserGroupCreated, error)
	/*
	   DeleteUserGroup deletes user group

	   Delete user group*/
	DeleteUserGroup(ctx context.Context, params *DeleteUserGroupParams) (*DeleteUserGroupOK, error)
	/*
	   GetUserGroup gets user group information

	   Get user group information*/
	GetUserGroup(ctx context.Context, params *GetUserGroupParams) (*GetUserGroupOK, error)
	/*
	   ListUserGroups gets all user groups information

	   Get all user groups information, it is open for system admin*/
	ListUserGroups(ctx context.Context, params *ListUserGroupsParams) (*ListUserGroupsOK, error)
	/*
	   SearchUserGroups searches groups by groupname

	   This endpoint is to search groups by group name.  It's open for all authenticated requests.
	*/
	SearchUserGroups(ctx context.Context, params *SearchUserGroupsParams) (*SearchUserGroupsOK, error)
	/*
	   UpdateUserGroup updates group information

	   Update user group information*/
	UpdateUserGroup(ctx context.Context, params *UpdateUserGroupParams) (*UpdateUserGroupOK, error)
}

// New creates a new usergroup API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry, authInfo runtime.ClientAuthInfoWriter) *Client {
	return &Client{
		transport: transport,
		formats:   formats,
		authInfo:  authInfo,
	}
}

/*
Client for usergroup API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
	authInfo  runtime.ClientAuthInfoWriter
}

/*
CreateUserGroup creates user group

Create user group information
*/
func (a *Client) CreateUserGroup(ctx context.Context, params *CreateUserGroupParams) (*CreateUserGroupCreated, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "createUserGroup",
		Method:             "POST",
		PathPattern:        "/usergroups",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &CreateUserGroupReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*CreateUserGroupCreated), nil

}

/*
DeleteUserGroup deletes user group

Delete user group
*/
func (a *Client) DeleteUserGroup(ctx context.Context, params *DeleteUserGroupParams) (*DeleteUserGroupOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteUserGroup",
		Method:             "DELETE",
		PathPattern:        "/usergroups/{group_id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &DeleteUserGroupReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*DeleteUserGroupOK), nil

}

/*
GetUserGroup gets user group information

Get user group information
*/
func (a *Client) GetUserGroup(ctx context.Context, params *GetUserGroupParams) (*GetUserGroupOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getUserGroup",
		Method:             "GET",
		PathPattern:        "/usergroups/{group_id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetUserGroupReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUserGroupOK), nil

}

/*
ListUserGroups gets all user groups information

Get all user groups information, it is open for system admin
*/
func (a *Client) ListUserGroups(ctx context.Context, params *ListUserGroupsParams) (*ListUserGroupsOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "listUserGroups",
		Method:             "GET",
		PathPattern:        "/usergroups",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ListUserGroupsReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*ListUserGroupsOK), nil

}

/*
SearchUserGroups searches groups by groupname

This endpoint is to search groups by group name.  It's open for all authenticated requests.
*/
func (a *Client) SearchUserGroups(ctx context.Context, params *SearchUserGroupsParams) (*SearchUserGroupsOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "searchUserGroups",
		Method:             "GET",
		PathPattern:        "/usergroups/search",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &SearchUserGroupsReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*SearchUserGroupsOK), nil

}

/*
UpdateUserGroup updates group information

Update user group information
*/
func (a *Client) UpdateUserGroup(ctx context.Context, params *UpdateUserGroupParams) (*UpdateUserGroupOK, error) {

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "updateUserGroup",
		Method:             "PUT",
		PathPattern:        "/usergroups/{group_id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &UpdateUserGroupReader{formats: a.formats},
		AuthInfo:           a.authInfo,
		Context:            ctx,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*UpdateUserGroupOK), nil

}
