// Code generated by go-swagger; DO NOT EDIT.

package webhook

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDeleteWebhookPolicyOfProjectParams creates a new DeleteWebhookPolicyOfProjectParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteWebhookPolicyOfProjectParams() *DeleteWebhookPolicyOfProjectParams {
	return &DeleteWebhookPolicyOfProjectParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteWebhookPolicyOfProjectParamsWithTimeout creates a new DeleteWebhookPolicyOfProjectParams object
// with the ability to set a timeout on a request.
func NewDeleteWebhookPolicyOfProjectParamsWithTimeout(timeout time.Duration) *DeleteWebhookPolicyOfProjectParams {
	return &DeleteWebhookPolicyOfProjectParams{
		timeout: timeout,
	}
}

// NewDeleteWebhookPolicyOfProjectParamsWithContext creates a new DeleteWebhookPolicyOfProjectParams object
// with the ability to set a context for a request.
func NewDeleteWebhookPolicyOfProjectParamsWithContext(ctx context.Context) *DeleteWebhookPolicyOfProjectParams {
	return &DeleteWebhookPolicyOfProjectParams{
		Context: ctx,
	}
}

// NewDeleteWebhookPolicyOfProjectParamsWithHTTPClient creates a new DeleteWebhookPolicyOfProjectParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteWebhookPolicyOfProjectParamsWithHTTPClient(client *http.Client) *DeleteWebhookPolicyOfProjectParams {
	return &DeleteWebhookPolicyOfProjectParams{
		HTTPClient: client,
	}
}

/*
DeleteWebhookPolicyOfProjectParams contains all the parameters to send to the API endpoint

	for the delete webhook policy of project operation.

	Typically these are written to a http.Request.
*/
type DeleteWebhookPolicyOfProjectParams struct {

	/* XIsResourceName.

	   The flag to indicate whether the parameter which supports both name and id in the path is the name of the resource. When the X-Is-Resource-Name is false and the parameter can be converted to an integer, the parameter will be as an id, otherwise, it will be as a name.
	*/
	XIsResourceName *bool

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* ProjectNameOrID.

	   The name or id of the project
	*/
	ProjectNameOrID string

	/* WebhookPolicyID.

	   The ID of the webhook policy

	   Format: int64
	*/
	WebhookPolicyID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete webhook policy of project params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteWebhookPolicyOfProjectParams) WithDefaults() *DeleteWebhookPolicyOfProjectParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete webhook policy of project params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteWebhookPolicyOfProjectParams) SetDefaults() {
	var (
		xIsResourceNameDefault = bool(false)
	)

	val := DeleteWebhookPolicyOfProjectParams{
		XIsResourceName: &xIsResourceNameDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) WithTimeout(timeout time.Duration) *DeleteWebhookPolicyOfProjectParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) WithContext(ctx context.Context) *DeleteWebhookPolicyOfProjectParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) WithHTTPClient(client *http.Client) *DeleteWebhookPolicyOfProjectParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXIsResourceName adds the xIsResourceName to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) WithXIsResourceName(xIsResourceName *bool) *DeleteWebhookPolicyOfProjectParams {
	o.SetXIsResourceName(xIsResourceName)
	return o
}

// SetXIsResourceName adds the xIsResourceName to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) SetXIsResourceName(xIsResourceName *bool) {
	o.XIsResourceName = xIsResourceName
}

// WithXRequestID adds the xRequestID to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) WithXRequestID(xRequestID *string) *DeleteWebhookPolicyOfProjectParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithProjectNameOrID adds the projectNameOrID to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) WithProjectNameOrID(projectNameOrID string) *DeleteWebhookPolicyOfProjectParams {
	o.SetProjectNameOrID(projectNameOrID)
	return o
}

// SetProjectNameOrID adds the projectNameOrId to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) SetProjectNameOrID(projectNameOrID string) {
	o.ProjectNameOrID = projectNameOrID
}

// WithWebhookPolicyID adds the webhookPolicyID to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) WithWebhookPolicyID(webhookPolicyID int64) *DeleteWebhookPolicyOfProjectParams {
	o.SetWebhookPolicyID(webhookPolicyID)
	return o
}

// SetWebhookPolicyID adds the webhookPolicyId to the delete webhook policy of project params
func (o *DeleteWebhookPolicyOfProjectParams) SetWebhookPolicyID(webhookPolicyID int64) {
	o.WebhookPolicyID = webhookPolicyID
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteWebhookPolicyOfProjectParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XIsResourceName != nil {

		// header param X-Is-Resource-Name
		if err := r.SetHeaderParam("X-Is-Resource-Name", swag.FormatBool(*o.XIsResourceName)); err != nil {
			return err
		}
	}

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param project_name_or_id
	if err := r.SetPathParam("project_name_or_id", o.ProjectNameOrID); err != nil {
		return err
	}

	// path param webhook_policy_id
	if err := r.SetPathParam("webhook_policy_id", swag.FormatInt64(o.WebhookPolicyID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
