// Code generated by go-swagger; DO NOT EDIT.

package webhook

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetLogsOfWebhookTaskParams creates a new GetLogsOfWebhookTaskParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetLogsOfWebhookTaskParams() *GetLogsOfWebhookTaskParams {
	return &GetLogsOfWebhookTaskParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetLogsOfWebhookTaskParamsWithTimeout creates a new GetLogsOfWebhookTaskParams object
// with the ability to set a timeout on a request.
func NewGetLogsOfWebhookTaskParamsWithTimeout(timeout time.Duration) *GetLogsOfWebhookTaskParams {
	return &GetLogsOfWebhookTaskParams{
		timeout: timeout,
	}
}

// NewGetLogsOfWebhookTaskParamsWithContext creates a new GetLogsOfWebhookTaskParams object
// with the ability to set a context for a request.
func NewGetLogsOfWebhookTaskParamsWithContext(ctx context.Context) *GetLogsOfWebhookTaskParams {
	return &GetLogsOfWebhookTaskParams{
		Context: ctx,
	}
}

// NewGetLogsOfWebhookTaskParamsWithHTTPClient creates a new GetLogsOfWebhookTaskParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetLogsOfWebhookTaskParamsWithHTTPClient(client *http.Client) *GetLogsOfWebhookTaskParams {
	return &GetLogsOfWebhookTaskParams{
		HTTPClient: client,
	}
}

/*
GetLogsOfWebhookTaskParams contains all the parameters to send to the API endpoint

	for the get logs of webhook task operation.

	Typically these are written to a http.Request.
*/
type GetLogsOfWebhookTaskParams struct {

	/* XIsResourceName.

	   The flag to indicate whether the parameter which supports both name and id in the path is the name of the resource. When the X-Is-Resource-Name is false and the parameter can be converted to an integer, the parameter will be as an id, otherwise, it will be as a name.
	*/
	XIsResourceName *bool

	/* XRequestID.

	   An unique ID for the request
	*/
	XRequestID *string

	/* ExecutionID.

	   Execution ID
	*/
	ExecutionID int64

	/* ProjectNameOrID.

	   The name or id of the project
	*/
	ProjectNameOrID string

	/* TaskID.

	   Task ID
	*/
	TaskID int64

	/* WebhookPolicyID.

	   The ID of the webhook policy

	   Format: int64
	*/
	WebhookPolicyID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get logs of webhook task params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLogsOfWebhookTaskParams) WithDefaults() *GetLogsOfWebhookTaskParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get logs of webhook task params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLogsOfWebhookTaskParams) SetDefaults() {
	var (
		xIsResourceNameDefault = bool(false)
	)

	val := GetLogsOfWebhookTaskParams{
		XIsResourceName: &xIsResourceNameDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) WithTimeout(timeout time.Duration) *GetLogsOfWebhookTaskParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) WithContext(ctx context.Context) *GetLogsOfWebhookTaskParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) WithHTTPClient(client *http.Client) *GetLogsOfWebhookTaskParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXIsResourceName adds the xIsResourceName to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) WithXIsResourceName(xIsResourceName *bool) *GetLogsOfWebhookTaskParams {
	o.SetXIsResourceName(xIsResourceName)
	return o
}

// SetXIsResourceName adds the xIsResourceName to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) SetXIsResourceName(xIsResourceName *bool) {
	o.XIsResourceName = xIsResourceName
}

// WithXRequestID adds the xRequestID to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) WithXRequestID(xRequestID *string) *GetLogsOfWebhookTaskParams {
	o.SetXRequestID(xRequestID)
	return o
}

// SetXRequestID adds the xRequestId to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) SetXRequestID(xRequestID *string) {
	o.XRequestID = xRequestID
}

// WithExecutionID adds the executionID to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) WithExecutionID(executionID int64) *GetLogsOfWebhookTaskParams {
	o.SetExecutionID(executionID)
	return o
}

// SetExecutionID adds the executionId to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) SetExecutionID(executionID int64) {
	o.ExecutionID = executionID
}

// WithProjectNameOrID adds the projectNameOrID to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) WithProjectNameOrID(projectNameOrID string) *GetLogsOfWebhookTaskParams {
	o.SetProjectNameOrID(projectNameOrID)
	return o
}

// SetProjectNameOrID adds the projectNameOrId to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) SetProjectNameOrID(projectNameOrID string) {
	o.ProjectNameOrID = projectNameOrID
}

// WithTaskID adds the taskID to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) WithTaskID(taskID int64) *GetLogsOfWebhookTaskParams {
	o.SetTaskID(taskID)
	return o
}

// SetTaskID adds the taskId to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) SetTaskID(taskID int64) {
	o.TaskID = taskID
}

// WithWebhookPolicyID adds the webhookPolicyID to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) WithWebhookPolicyID(webhookPolicyID int64) *GetLogsOfWebhookTaskParams {
	o.SetWebhookPolicyID(webhookPolicyID)
	return o
}

// SetWebhookPolicyID adds the webhookPolicyId to the get logs of webhook task params
func (o *GetLogsOfWebhookTaskParams) SetWebhookPolicyID(webhookPolicyID int64) {
	o.WebhookPolicyID = webhookPolicyID
}

// WriteToRequest writes these params to a swagger request
func (o *GetLogsOfWebhookTaskParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XIsResourceName != nil {

		// header param X-Is-Resource-Name
		if err := r.SetHeaderParam("X-Is-Resource-Name", swag.FormatBool(*o.XIsResourceName)); err != nil {
			return err
		}
	}

	if o.XRequestID != nil {

		// header param X-Request-Id
		if err := r.SetHeaderParam("X-Request-Id", *o.XRequestID); err != nil {
			return err
		}
	}

	// path param execution_id
	if err := r.SetPathParam("execution_id", swag.FormatInt64(o.ExecutionID)); err != nil {
		return err
	}

	// path param project_name_or_id
	if err := r.SetPathParam("project_name_or_id", o.ProjectNameOrID); err != nil {
		return err
	}

	// path param task_id
	if err := r.SetPathParam("task_id", swag.FormatInt64(o.TaskID)); err != nil {
		return err
	}

	// path param webhook_policy_id
	if err := r.SetPathParam("webhook_policy_id", swag.FormatInt64(o.WebhookPolicyID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
