// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// ConfigurationsResponse configurations response
//
// swagger:model ConfigurationsResponse
type ConfigurationsResponse struct {

	// The endpoint of the audit log forwarder
	AuditLogForwardEndpoint *StringConfigItem `json:"audit_log_forward_endpoint,omitempty"`

	// The auth mode of current system, such as "db_auth", "ldap_auth", "oidc_auth"
	AuthMode *StringConfigItem `json:"auth_mode,omitempty"`

	// The banner message for the UI.It is the stringified result of the banner message object
	BannerMessage *StringConfigItem `json:"banner_message,omitempty"`

	// The group which has the harbor admin privileges
	HTTPAuthproxyAdminGroups *StringConfigItem `json:"http_authproxy_admin_groups,omitempty"`

	// The usernames which has the harbor admin privileges
	HTTPAuthproxyAdminUsernames *StringConfigItem `json:"http_authproxy_admin_usernames,omitempty"`

	// The endpoint of the HTTP auth
	HTTPAuthproxyEndpoint *StringConfigItem `json:"http_authproxy_endpoint,omitempty"`

	// The certificate of the HTTP auth provider
	HTTPAuthproxyServerCertificate *StringConfigItem `json:"http_authproxy_server_certificate,omitempty"`

	// Search user before onboard
	HTTPAuthproxySkipSearch *BoolConfigItem `json:"http_authproxy_skip_search,omitempty"`

	// The token review endpoint
	HTTPAuthproxyTokenreviewEndpoint *StringConfigItem `json:"http_authproxy_tokenreview_endpoint,omitempty"`

	// Verify the HTTP auth provider's certificate
	HTTPAuthproxyVerifyCert *BoolConfigItem `json:"http_authproxy_verify_cert,omitempty"`

	// The Base DN for LDAP binding.
	LdapBaseDn *StringConfigItem `json:"ldap_base_dn,omitempty"`

	// The filter for LDAP search
	LdapFilter *StringConfigItem `json:"ldap_filter,omitempty"`

	// Specify the ldap group which have the same privilege with Harbor admin
	LdapGroupAdminDn *StringConfigItem `json:"ldap_group_admin_dn,omitempty"`

	// The attribute which is used as identity of the LDAP group, default is cn.'
	LdapGroupAttributeName *StringConfigItem `json:"ldap_group_attribute_name,omitempty"`

	// The base DN to search LDAP group.
	LdapGroupBaseDn *StringConfigItem `json:"ldap_group_base_dn,omitempty"`

	// The user attribute to identify the group membership
	LdapGroupMembershipAttribute *StringConfigItem `json:"ldap_group_membership_attribute,omitempty"`

	// The filter to search the ldap group
	LdapGroupSearchFilter *StringConfigItem `json:"ldap_group_search_filter,omitempty"`

	// The scope to search ldap group. ''0-LDAP_SCOPE_BASE, 1-LDAP_SCOPE_ONELEVEL, 2-LDAP_SCOPE_SUBTREE''
	LdapGroupSearchScope *IntegerConfigItem `json:"ldap_group_search_scope,omitempty"`

	// The scope to search ldap users,'0-LDAP_SCOPE_BASE, 1-LDAP_SCOPE_ONELEVEL, 2-LDAP_SCOPE_SUBTREE'
	LdapScope *IntegerConfigItem `json:"ldap_scope,omitempty"`

	// The DN of the user to do the search.
	LdapSearchDn *StringConfigItem `json:"ldap_search_dn,omitempty"`

	// Timeout in seconds for connection to LDAP server
	LdapTimeout *IntegerConfigItem `json:"ldap_timeout,omitempty"`

	// The attribute which is used as identity for the LDAP binding, such as "CN" or "SAMAccountname"
	LdapUID *StringConfigItem `json:"ldap_uid,omitempty"`

	// The URL of LDAP server
	LdapURL *StringConfigItem `json:"ldap_url,omitempty"`

	// Whether verify your OIDC server certificate, disable it if your OIDC server is hosted via self-hosted certificate.
	LdapVerifyCert *BoolConfigItem `json:"ldap_verify_cert,omitempty"`

	// Enable notification
	NotificationEnable *BoolConfigItem `json:"notification_enable,omitempty"`

	// The OIDC group which has the harbor admin privileges
	OIDCAdminGroup *StringConfigItem `json:"oidc_admin_group,omitempty"`

	// Auto onboard the OIDC user
	OIDCAutoOnboard *BoolConfigItem `json:"oidc_auto_onboard,omitempty"`

	// The client ID of the OIDC provider
	OIDCClientID *StringConfigItem `json:"oidc_client_id,omitempty"`

	// The endpoint of the OIDC provider
	OIDCEndpoint *StringConfigItem `json:"oidc_endpoint,omitempty"`

	// Extra parameters to add when redirect request to OIDC provider
	OIDCExtraRedirectParms *StringConfigItem `json:"oidc_extra_redirect_parms,omitempty"`

	// The OIDC group filter which filters out the group doesn't match the regular expression
	OIDCGroupFilter *StringConfigItem `json:"oidc_group_filter,omitempty"`

	// The attribute claims the group name
	OIDCGroupsClaim *StringConfigItem `json:"oidc_groups_claim,omitempty"`

	// The OIDC provider name
	OIDCName *StringConfigItem `json:"oidc_name,omitempty"`

	// The scope of the OIDC provider
	OIDCScope *StringConfigItem `json:"oidc_scope,omitempty"`

	// The attribute claims the username
	OIDCUserClaim *StringConfigItem `json:"oidc_user_claim,omitempty"`

	// Verify the OIDC provider's certificate'
	OIDCVerifyCert *BoolConfigItem `json:"oidc_verify_cert,omitempty"`

	// The flag to indicate whether the current auth mode should consider as a primary one.
	PrimaryAuthMode *BoolConfigItem `json:"primary_auth_mode,omitempty"`

	// Indicate who can create projects, it could be ''adminonly'' or ''everyone''.
	ProjectCreationRestriction *StringConfigItem `json:"project_creation_restriction,omitempty"`

	// Enable quota per project
	QuotaPerProjectEnable *BoolConfigItem `json:"quota_per_project_enable,omitempty"`

	// The flag to indicate whether Harbor is in readonly mode.
	ReadOnly *BoolConfigItem `json:"read_only,omitempty"`

	// The rebot account name prefix
	RobotNamePrefix *StringConfigItem `json:"robot_name_prefix,omitempty"`

	// The robot account token duration in days
	RobotTokenDuration *IntegerConfigItem `json:"robot_token_duration,omitempty"`

	// scan all policy
	ScanAllPolicy *ConfigurationsResponseScanAllPolicy `json:"scan_all_policy,omitempty"`

	// Whether or not to skip update the pull time for scanner
	ScannerSkipUpdatePulltime *BoolConfigItem `json:"scanner_skip_update_pulltime,omitempty"`

	// Whether the Harbor instance supports self-registration.  If it''s set to false, admin need to add user to the instance.
	SelfRegistration *BoolConfigItem `json:"self_registration,omitempty"`

	// The session timeout in minutes
	SessionTimeout *IntegerConfigItem `json:"session_timeout,omitempty"`

	// Whether skip the audit log in database
	SkipAuditLogDatabase *BoolConfigItem `json:"skip_audit_log_database,omitempty"`

	// The storage quota per project
	StoragePerProject *IntegerConfigItem `json:"storage_per_project,omitempty"`

	// The expiration time of the token for internal Registry, in minutes.
	TokenExpiration *IntegerConfigItem `json:"token_expiration,omitempty"`

	// The client id of UAA
	UaaClientID *StringConfigItem `json:"uaa_client_id,omitempty"`

	// The client secret of the UAA
	UaaClientSecret *StringConfigItem `json:"uaa_client_secret,omitempty"`

	// The endpoint of the UAA
	UaaEndpoint *StringConfigItem `json:"uaa_endpoint,omitempty"`

	// Verify the certificate in UAA server
	UaaVerifyCert *BoolConfigItem `json:"uaa_verify_cert,omitempty"`
}

// Validate validates this configurations response
func (m *ConfigurationsResponse) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAuditLogForwardEndpoint(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAuthMode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateBannerMessage(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHTTPAuthproxyAdminGroups(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHTTPAuthproxyAdminUsernames(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHTTPAuthproxyEndpoint(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHTTPAuthproxyServerCertificate(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHTTPAuthproxySkipSearch(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHTTPAuthproxyTokenreviewEndpoint(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHTTPAuthproxyVerifyCert(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapBaseDn(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapFilter(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapGroupAdminDn(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapGroupAttributeName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapGroupBaseDn(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapGroupMembershipAttribute(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapGroupSearchFilter(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapGroupSearchScope(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapScope(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapSearchDn(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapTimeout(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapUID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapURL(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLdapVerifyCert(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNotificationEnable(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCAdminGroup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCAutoOnboard(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCClientID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCEndpoint(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCExtraRedirectParms(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCGroupFilter(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCGroupsClaim(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCScope(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCUserClaim(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOIDCVerifyCert(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePrimaryAuthMode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProjectCreationRestriction(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateQuotaPerProjectEnable(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateReadOnly(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRobotNamePrefix(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRobotTokenDuration(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateScanAllPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateScannerSkipUpdatePulltime(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSelfRegistration(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSessionTimeout(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSkipAuditLogDatabase(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStoragePerProject(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTokenExpiration(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUaaClientID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUaaClientSecret(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUaaEndpoint(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUaaVerifyCert(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConfigurationsResponse) validateAuditLogForwardEndpoint(formats strfmt.Registry) error {
	if swag.IsZero(m.AuditLogForwardEndpoint) { // not required
		return nil
	}

	if m.AuditLogForwardEndpoint != nil {
		if err := m.AuditLogForwardEndpoint.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("audit_log_forward_endpoint")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("audit_log_forward_endpoint")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateAuthMode(formats strfmt.Registry) error {
	if swag.IsZero(m.AuthMode) { // not required
		return nil
	}

	if m.AuthMode != nil {
		if err := m.AuthMode.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("auth_mode")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("auth_mode")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateBannerMessage(formats strfmt.Registry) error {
	if swag.IsZero(m.BannerMessage) { // not required
		return nil
	}

	if m.BannerMessage != nil {
		if err := m.BannerMessage.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("banner_message")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("banner_message")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateHTTPAuthproxyAdminGroups(formats strfmt.Registry) error {
	if swag.IsZero(m.HTTPAuthproxyAdminGroups) { // not required
		return nil
	}

	if m.HTTPAuthproxyAdminGroups != nil {
		if err := m.HTTPAuthproxyAdminGroups.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_admin_groups")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_admin_groups")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateHTTPAuthproxyAdminUsernames(formats strfmt.Registry) error {
	if swag.IsZero(m.HTTPAuthproxyAdminUsernames) { // not required
		return nil
	}

	if m.HTTPAuthproxyAdminUsernames != nil {
		if err := m.HTTPAuthproxyAdminUsernames.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_admin_usernames")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_admin_usernames")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateHTTPAuthproxyEndpoint(formats strfmt.Registry) error {
	if swag.IsZero(m.HTTPAuthproxyEndpoint) { // not required
		return nil
	}

	if m.HTTPAuthproxyEndpoint != nil {
		if err := m.HTTPAuthproxyEndpoint.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_endpoint")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_endpoint")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateHTTPAuthproxyServerCertificate(formats strfmt.Registry) error {
	if swag.IsZero(m.HTTPAuthproxyServerCertificate) { // not required
		return nil
	}

	if m.HTTPAuthproxyServerCertificate != nil {
		if err := m.HTTPAuthproxyServerCertificate.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_server_certificate")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_server_certificate")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateHTTPAuthproxySkipSearch(formats strfmt.Registry) error {
	if swag.IsZero(m.HTTPAuthproxySkipSearch) { // not required
		return nil
	}

	if m.HTTPAuthproxySkipSearch != nil {
		if err := m.HTTPAuthproxySkipSearch.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_skip_search")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_skip_search")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateHTTPAuthproxyTokenreviewEndpoint(formats strfmt.Registry) error {
	if swag.IsZero(m.HTTPAuthproxyTokenreviewEndpoint) { // not required
		return nil
	}

	if m.HTTPAuthproxyTokenreviewEndpoint != nil {
		if err := m.HTTPAuthproxyTokenreviewEndpoint.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_tokenreview_endpoint")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_tokenreview_endpoint")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateHTTPAuthproxyVerifyCert(formats strfmt.Registry) error {
	if swag.IsZero(m.HTTPAuthproxyVerifyCert) { // not required
		return nil
	}

	if m.HTTPAuthproxyVerifyCert != nil {
		if err := m.HTTPAuthproxyVerifyCert.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_verify_cert")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_verify_cert")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapBaseDn(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapBaseDn) { // not required
		return nil
	}

	if m.LdapBaseDn != nil {
		if err := m.LdapBaseDn.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_base_dn")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_base_dn")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapFilter(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapFilter) { // not required
		return nil
	}

	if m.LdapFilter != nil {
		if err := m.LdapFilter.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_filter")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_filter")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapGroupAdminDn(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapGroupAdminDn) { // not required
		return nil
	}

	if m.LdapGroupAdminDn != nil {
		if err := m.LdapGroupAdminDn.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_admin_dn")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_admin_dn")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapGroupAttributeName(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapGroupAttributeName) { // not required
		return nil
	}

	if m.LdapGroupAttributeName != nil {
		if err := m.LdapGroupAttributeName.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_attribute_name")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_attribute_name")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapGroupBaseDn(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapGroupBaseDn) { // not required
		return nil
	}

	if m.LdapGroupBaseDn != nil {
		if err := m.LdapGroupBaseDn.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_base_dn")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_base_dn")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapGroupMembershipAttribute(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapGroupMembershipAttribute) { // not required
		return nil
	}

	if m.LdapGroupMembershipAttribute != nil {
		if err := m.LdapGroupMembershipAttribute.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_membership_attribute")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_membership_attribute")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapGroupSearchFilter(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapGroupSearchFilter) { // not required
		return nil
	}

	if m.LdapGroupSearchFilter != nil {
		if err := m.LdapGroupSearchFilter.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_search_filter")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_search_filter")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapGroupSearchScope(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapGroupSearchScope) { // not required
		return nil
	}

	if m.LdapGroupSearchScope != nil {
		if err := m.LdapGroupSearchScope.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_search_scope")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_search_scope")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapScope(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapScope) { // not required
		return nil
	}

	if m.LdapScope != nil {
		if err := m.LdapScope.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_scope")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_scope")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapSearchDn(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapSearchDn) { // not required
		return nil
	}

	if m.LdapSearchDn != nil {
		if err := m.LdapSearchDn.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_search_dn")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_search_dn")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapTimeout(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapTimeout) { // not required
		return nil
	}

	if m.LdapTimeout != nil {
		if err := m.LdapTimeout.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_timeout")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_timeout")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapUID(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapUID) { // not required
		return nil
	}

	if m.LdapUID != nil {
		if err := m.LdapUID.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_uid")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_uid")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapURL(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapURL) { // not required
		return nil
	}

	if m.LdapURL != nil {
		if err := m.LdapURL.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_url")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_url")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateLdapVerifyCert(formats strfmt.Registry) error {
	if swag.IsZero(m.LdapVerifyCert) { // not required
		return nil
	}

	if m.LdapVerifyCert != nil {
		if err := m.LdapVerifyCert.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_verify_cert")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_verify_cert")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateNotificationEnable(formats strfmt.Registry) error {
	if swag.IsZero(m.NotificationEnable) { // not required
		return nil
	}

	if m.NotificationEnable != nil {
		if err := m.NotificationEnable.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("notification_enable")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("notification_enable")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCAdminGroup(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCAdminGroup) { // not required
		return nil
	}

	if m.OIDCAdminGroup != nil {
		if err := m.OIDCAdminGroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_admin_group")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_admin_group")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCAutoOnboard(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCAutoOnboard) { // not required
		return nil
	}

	if m.OIDCAutoOnboard != nil {
		if err := m.OIDCAutoOnboard.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_auto_onboard")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_auto_onboard")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCClientID(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCClientID) { // not required
		return nil
	}

	if m.OIDCClientID != nil {
		if err := m.OIDCClientID.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_client_id")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_client_id")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCEndpoint(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCEndpoint) { // not required
		return nil
	}

	if m.OIDCEndpoint != nil {
		if err := m.OIDCEndpoint.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_endpoint")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_endpoint")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCExtraRedirectParms(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCExtraRedirectParms) { // not required
		return nil
	}

	if m.OIDCExtraRedirectParms != nil {
		if err := m.OIDCExtraRedirectParms.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_extra_redirect_parms")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_extra_redirect_parms")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCGroupFilter(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCGroupFilter) { // not required
		return nil
	}

	if m.OIDCGroupFilter != nil {
		if err := m.OIDCGroupFilter.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_group_filter")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_group_filter")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCGroupsClaim(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCGroupsClaim) { // not required
		return nil
	}

	if m.OIDCGroupsClaim != nil {
		if err := m.OIDCGroupsClaim.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_groups_claim")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_groups_claim")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCName(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCName) { // not required
		return nil
	}

	if m.OIDCName != nil {
		if err := m.OIDCName.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_name")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_name")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCScope(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCScope) { // not required
		return nil
	}

	if m.OIDCScope != nil {
		if err := m.OIDCScope.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_scope")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_scope")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCUserClaim(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCUserClaim) { // not required
		return nil
	}

	if m.OIDCUserClaim != nil {
		if err := m.OIDCUserClaim.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_user_claim")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_user_claim")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateOIDCVerifyCert(formats strfmt.Registry) error {
	if swag.IsZero(m.OIDCVerifyCert) { // not required
		return nil
	}

	if m.OIDCVerifyCert != nil {
		if err := m.OIDCVerifyCert.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_verify_cert")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_verify_cert")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validatePrimaryAuthMode(formats strfmt.Registry) error {
	if swag.IsZero(m.PrimaryAuthMode) { // not required
		return nil
	}

	if m.PrimaryAuthMode != nil {
		if err := m.PrimaryAuthMode.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("primary_auth_mode")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("primary_auth_mode")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateProjectCreationRestriction(formats strfmt.Registry) error {
	if swag.IsZero(m.ProjectCreationRestriction) { // not required
		return nil
	}

	if m.ProjectCreationRestriction != nil {
		if err := m.ProjectCreationRestriction.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("project_creation_restriction")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("project_creation_restriction")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateQuotaPerProjectEnable(formats strfmt.Registry) error {
	if swag.IsZero(m.QuotaPerProjectEnable) { // not required
		return nil
	}

	if m.QuotaPerProjectEnable != nil {
		if err := m.QuotaPerProjectEnable.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("quota_per_project_enable")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("quota_per_project_enable")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateReadOnly(formats strfmt.Registry) error {
	if swag.IsZero(m.ReadOnly) { // not required
		return nil
	}

	if m.ReadOnly != nil {
		if err := m.ReadOnly.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("read_only")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("read_only")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateRobotNamePrefix(formats strfmt.Registry) error {
	if swag.IsZero(m.RobotNamePrefix) { // not required
		return nil
	}

	if m.RobotNamePrefix != nil {
		if err := m.RobotNamePrefix.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("robot_name_prefix")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("robot_name_prefix")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateRobotTokenDuration(formats strfmt.Registry) error {
	if swag.IsZero(m.RobotTokenDuration) { // not required
		return nil
	}

	if m.RobotTokenDuration != nil {
		if err := m.RobotTokenDuration.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("robot_token_duration")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("robot_token_duration")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateScanAllPolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.ScanAllPolicy) { // not required
		return nil
	}

	if m.ScanAllPolicy != nil {
		if err := m.ScanAllPolicy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("scan_all_policy")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("scan_all_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateScannerSkipUpdatePulltime(formats strfmt.Registry) error {
	if swag.IsZero(m.ScannerSkipUpdatePulltime) { // not required
		return nil
	}

	if m.ScannerSkipUpdatePulltime != nil {
		if err := m.ScannerSkipUpdatePulltime.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("scanner_skip_update_pulltime")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("scanner_skip_update_pulltime")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateSelfRegistration(formats strfmt.Registry) error {
	if swag.IsZero(m.SelfRegistration) { // not required
		return nil
	}

	if m.SelfRegistration != nil {
		if err := m.SelfRegistration.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("self_registration")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("self_registration")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateSessionTimeout(formats strfmt.Registry) error {
	if swag.IsZero(m.SessionTimeout) { // not required
		return nil
	}

	if m.SessionTimeout != nil {
		if err := m.SessionTimeout.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("session_timeout")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("session_timeout")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateSkipAuditLogDatabase(formats strfmt.Registry) error {
	if swag.IsZero(m.SkipAuditLogDatabase) { // not required
		return nil
	}

	if m.SkipAuditLogDatabase != nil {
		if err := m.SkipAuditLogDatabase.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("skip_audit_log_database")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("skip_audit_log_database")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateStoragePerProject(formats strfmt.Registry) error {
	if swag.IsZero(m.StoragePerProject) { // not required
		return nil
	}

	if m.StoragePerProject != nil {
		if err := m.StoragePerProject.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("storage_per_project")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("storage_per_project")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateTokenExpiration(formats strfmt.Registry) error {
	if swag.IsZero(m.TokenExpiration) { // not required
		return nil
	}

	if m.TokenExpiration != nil {
		if err := m.TokenExpiration.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("token_expiration")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("token_expiration")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateUaaClientID(formats strfmt.Registry) error {
	if swag.IsZero(m.UaaClientID) { // not required
		return nil
	}

	if m.UaaClientID != nil {
		if err := m.UaaClientID.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("uaa_client_id")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("uaa_client_id")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateUaaClientSecret(formats strfmt.Registry) error {
	if swag.IsZero(m.UaaClientSecret) { // not required
		return nil
	}

	if m.UaaClientSecret != nil {
		if err := m.UaaClientSecret.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("uaa_client_secret")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("uaa_client_secret")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateUaaEndpoint(formats strfmt.Registry) error {
	if swag.IsZero(m.UaaEndpoint) { // not required
		return nil
	}

	if m.UaaEndpoint != nil {
		if err := m.UaaEndpoint.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("uaa_endpoint")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("uaa_endpoint")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) validateUaaVerifyCert(formats strfmt.Registry) error {
	if swag.IsZero(m.UaaVerifyCert) { // not required
		return nil
	}

	if m.UaaVerifyCert != nil {
		if err := m.UaaVerifyCert.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("uaa_verify_cert")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("uaa_verify_cert")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this configurations response based on the context it is used
func (m *ConfigurationsResponse) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateAuditLogForwardEndpoint(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateAuthMode(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateBannerMessage(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHTTPAuthproxyAdminGroups(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHTTPAuthproxyAdminUsernames(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHTTPAuthproxyEndpoint(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHTTPAuthproxyServerCertificate(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHTTPAuthproxySkipSearch(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHTTPAuthproxyTokenreviewEndpoint(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHTTPAuthproxyVerifyCert(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapBaseDn(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapFilter(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapGroupAdminDn(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapGroupAttributeName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapGroupBaseDn(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapGroupMembershipAttribute(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapGroupSearchFilter(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapGroupSearchScope(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapScope(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapSearchDn(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapTimeout(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapURL(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLdapVerifyCert(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateNotificationEnable(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCAdminGroup(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCAutoOnboard(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCClientID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCEndpoint(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCExtraRedirectParms(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCGroupFilter(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCGroupsClaim(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCScope(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCUserClaim(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOIDCVerifyCert(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidatePrimaryAuthMode(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateProjectCreationRestriction(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateQuotaPerProjectEnable(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateReadOnly(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateRobotNamePrefix(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateRobotTokenDuration(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateScanAllPolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateScannerSkipUpdatePulltime(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSelfRegistration(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSessionTimeout(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSkipAuditLogDatabase(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateStoragePerProject(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTokenExpiration(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUaaClientID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUaaClientSecret(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUaaEndpoint(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUaaVerifyCert(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConfigurationsResponse) contextValidateAuditLogForwardEndpoint(ctx context.Context, formats strfmt.Registry) error {

	if m.AuditLogForwardEndpoint != nil {
		if err := m.AuditLogForwardEndpoint.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("audit_log_forward_endpoint")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("audit_log_forward_endpoint")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateAuthMode(ctx context.Context, formats strfmt.Registry) error {

	if m.AuthMode != nil {
		if err := m.AuthMode.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("auth_mode")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("auth_mode")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateBannerMessage(ctx context.Context, formats strfmt.Registry) error {

	if m.BannerMessage != nil {
		if err := m.BannerMessage.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("banner_message")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("banner_message")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateHTTPAuthproxyAdminGroups(ctx context.Context, formats strfmt.Registry) error {

	if m.HTTPAuthproxyAdminGroups != nil {
		if err := m.HTTPAuthproxyAdminGroups.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_admin_groups")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_admin_groups")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateHTTPAuthproxyAdminUsernames(ctx context.Context, formats strfmt.Registry) error {

	if m.HTTPAuthproxyAdminUsernames != nil {
		if err := m.HTTPAuthproxyAdminUsernames.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_admin_usernames")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_admin_usernames")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateHTTPAuthproxyEndpoint(ctx context.Context, formats strfmt.Registry) error {

	if m.HTTPAuthproxyEndpoint != nil {
		if err := m.HTTPAuthproxyEndpoint.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_endpoint")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_endpoint")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateHTTPAuthproxyServerCertificate(ctx context.Context, formats strfmt.Registry) error {

	if m.HTTPAuthproxyServerCertificate != nil {
		if err := m.HTTPAuthproxyServerCertificate.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_server_certificate")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_server_certificate")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateHTTPAuthproxySkipSearch(ctx context.Context, formats strfmt.Registry) error {

	if m.HTTPAuthproxySkipSearch != nil {
		if err := m.HTTPAuthproxySkipSearch.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_skip_search")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_skip_search")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateHTTPAuthproxyTokenreviewEndpoint(ctx context.Context, formats strfmt.Registry) error {

	if m.HTTPAuthproxyTokenreviewEndpoint != nil {
		if err := m.HTTPAuthproxyTokenreviewEndpoint.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_tokenreview_endpoint")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_tokenreview_endpoint")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateHTTPAuthproxyVerifyCert(ctx context.Context, formats strfmt.Registry) error {

	if m.HTTPAuthproxyVerifyCert != nil {
		if err := m.HTTPAuthproxyVerifyCert.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("http_authproxy_verify_cert")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("http_authproxy_verify_cert")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapBaseDn(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapBaseDn != nil {
		if err := m.LdapBaseDn.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_base_dn")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_base_dn")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapFilter(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapFilter != nil {
		if err := m.LdapFilter.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_filter")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_filter")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapGroupAdminDn(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapGroupAdminDn != nil {
		if err := m.LdapGroupAdminDn.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_admin_dn")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_admin_dn")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapGroupAttributeName(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapGroupAttributeName != nil {
		if err := m.LdapGroupAttributeName.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_attribute_name")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_attribute_name")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapGroupBaseDn(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapGroupBaseDn != nil {
		if err := m.LdapGroupBaseDn.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_base_dn")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_base_dn")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapGroupMembershipAttribute(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapGroupMembershipAttribute != nil {
		if err := m.LdapGroupMembershipAttribute.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_membership_attribute")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_membership_attribute")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapGroupSearchFilter(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapGroupSearchFilter != nil {
		if err := m.LdapGroupSearchFilter.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_search_filter")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_search_filter")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapGroupSearchScope(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapGroupSearchScope != nil {
		if err := m.LdapGroupSearchScope.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_group_search_scope")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_group_search_scope")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapScope(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapScope != nil {
		if err := m.LdapScope.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_scope")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_scope")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapSearchDn(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapSearchDn != nil {
		if err := m.LdapSearchDn.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_search_dn")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_search_dn")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapTimeout(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapTimeout != nil {
		if err := m.LdapTimeout.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_timeout")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_timeout")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapUID(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapUID != nil {
		if err := m.LdapUID.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_uid")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_uid")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapURL(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapURL != nil {
		if err := m.LdapURL.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_url")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_url")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateLdapVerifyCert(ctx context.Context, formats strfmt.Registry) error {

	if m.LdapVerifyCert != nil {
		if err := m.LdapVerifyCert.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ldap_verify_cert")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("ldap_verify_cert")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateNotificationEnable(ctx context.Context, formats strfmt.Registry) error {

	if m.NotificationEnable != nil {
		if err := m.NotificationEnable.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("notification_enable")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("notification_enable")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCAdminGroup(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCAdminGroup != nil {
		if err := m.OIDCAdminGroup.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_admin_group")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_admin_group")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCAutoOnboard(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCAutoOnboard != nil {
		if err := m.OIDCAutoOnboard.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_auto_onboard")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_auto_onboard")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCClientID(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCClientID != nil {
		if err := m.OIDCClientID.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_client_id")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_client_id")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCEndpoint(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCEndpoint != nil {
		if err := m.OIDCEndpoint.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_endpoint")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_endpoint")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCExtraRedirectParms(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCExtraRedirectParms != nil {
		if err := m.OIDCExtraRedirectParms.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_extra_redirect_parms")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_extra_redirect_parms")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCGroupFilter(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCGroupFilter != nil {
		if err := m.OIDCGroupFilter.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_group_filter")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_group_filter")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCGroupsClaim(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCGroupsClaim != nil {
		if err := m.OIDCGroupsClaim.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_groups_claim")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_groups_claim")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCName(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCName != nil {
		if err := m.OIDCName.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_name")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_name")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCScope(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCScope != nil {
		if err := m.OIDCScope.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_scope")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_scope")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCUserClaim(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCUserClaim != nil {
		if err := m.OIDCUserClaim.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_user_claim")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_user_claim")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateOIDCVerifyCert(ctx context.Context, formats strfmt.Registry) error {

	if m.OIDCVerifyCert != nil {
		if err := m.OIDCVerifyCert.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("oidc_verify_cert")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("oidc_verify_cert")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidatePrimaryAuthMode(ctx context.Context, formats strfmt.Registry) error {

	if m.PrimaryAuthMode != nil {
		if err := m.PrimaryAuthMode.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("primary_auth_mode")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("primary_auth_mode")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateProjectCreationRestriction(ctx context.Context, formats strfmt.Registry) error {

	if m.ProjectCreationRestriction != nil {
		if err := m.ProjectCreationRestriction.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("project_creation_restriction")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("project_creation_restriction")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateQuotaPerProjectEnable(ctx context.Context, formats strfmt.Registry) error {

	if m.QuotaPerProjectEnable != nil {
		if err := m.QuotaPerProjectEnable.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("quota_per_project_enable")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("quota_per_project_enable")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateReadOnly(ctx context.Context, formats strfmt.Registry) error {

	if m.ReadOnly != nil {
		if err := m.ReadOnly.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("read_only")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("read_only")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateRobotNamePrefix(ctx context.Context, formats strfmt.Registry) error {

	if m.RobotNamePrefix != nil {
		if err := m.RobotNamePrefix.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("robot_name_prefix")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("robot_name_prefix")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateRobotTokenDuration(ctx context.Context, formats strfmt.Registry) error {

	if m.RobotTokenDuration != nil {
		if err := m.RobotTokenDuration.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("robot_token_duration")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("robot_token_duration")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateScanAllPolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.ScanAllPolicy != nil {
		if err := m.ScanAllPolicy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("scan_all_policy")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("scan_all_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateScannerSkipUpdatePulltime(ctx context.Context, formats strfmt.Registry) error {

	if m.ScannerSkipUpdatePulltime != nil {
		if err := m.ScannerSkipUpdatePulltime.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("scanner_skip_update_pulltime")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("scanner_skip_update_pulltime")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateSelfRegistration(ctx context.Context, formats strfmt.Registry) error {

	if m.SelfRegistration != nil {
		if err := m.SelfRegistration.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("self_registration")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("self_registration")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateSessionTimeout(ctx context.Context, formats strfmt.Registry) error {

	if m.SessionTimeout != nil {
		if err := m.SessionTimeout.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("session_timeout")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("session_timeout")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateSkipAuditLogDatabase(ctx context.Context, formats strfmt.Registry) error {

	if m.SkipAuditLogDatabase != nil {
		if err := m.SkipAuditLogDatabase.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("skip_audit_log_database")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("skip_audit_log_database")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateStoragePerProject(ctx context.Context, formats strfmt.Registry) error {

	if m.StoragePerProject != nil {
		if err := m.StoragePerProject.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("storage_per_project")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("storage_per_project")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateTokenExpiration(ctx context.Context, formats strfmt.Registry) error {

	if m.TokenExpiration != nil {
		if err := m.TokenExpiration.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("token_expiration")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("token_expiration")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateUaaClientID(ctx context.Context, formats strfmt.Registry) error {

	if m.UaaClientID != nil {
		if err := m.UaaClientID.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("uaa_client_id")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("uaa_client_id")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateUaaClientSecret(ctx context.Context, formats strfmt.Registry) error {

	if m.UaaClientSecret != nil {
		if err := m.UaaClientSecret.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("uaa_client_secret")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("uaa_client_secret")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateUaaEndpoint(ctx context.Context, formats strfmt.Registry) error {

	if m.UaaEndpoint != nil {
		if err := m.UaaEndpoint.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("uaa_endpoint")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("uaa_endpoint")
			}
			return err
		}
	}

	return nil
}

func (m *ConfigurationsResponse) contextValidateUaaVerifyCert(ctx context.Context, formats strfmt.Registry) error {

	if m.UaaVerifyCert != nil {
		if err := m.UaaVerifyCert.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("uaa_verify_cert")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("uaa_verify_cert")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConfigurationsResponse) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConfigurationsResponse) UnmarshalBinary(b []byte) error {
	var res ConfigurationsResponse
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConfigurationsResponseScanAllPolicy configurations response scan all policy
//
// swagger:model ConfigurationsResponseScanAllPolicy
type ConfigurationsResponseScanAllPolicy struct {

	// parameter
	Parameter *ConfigurationsResponseScanAllPolicyParameter `json:"parameter,omitempty"`

	// The type of scan all policy, currently the valid values are "none" and "daily"
	Type string `json:"type,omitempty"`
}

// Validate validates this configurations response scan all policy
func (m *ConfigurationsResponseScanAllPolicy) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateParameter(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConfigurationsResponseScanAllPolicy) validateParameter(formats strfmt.Registry) error {
	if swag.IsZero(m.Parameter) { // not required
		return nil
	}

	if m.Parameter != nil {
		if err := m.Parameter.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("scan_all_policy" + "." + "parameter")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("scan_all_policy" + "." + "parameter")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this configurations response scan all policy based on the context it is used
func (m *ConfigurationsResponseScanAllPolicy) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateParameter(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConfigurationsResponseScanAllPolicy) contextValidateParameter(ctx context.Context, formats strfmt.Registry) error {

	if m.Parameter != nil {
		if err := m.Parameter.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("scan_all_policy" + "." + "parameter")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("scan_all_policy" + "." + "parameter")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConfigurationsResponseScanAllPolicy) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConfigurationsResponseScanAllPolicy) UnmarshalBinary(b []byte) error {
	var res ConfigurationsResponseScanAllPolicy
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConfigurationsResponseScanAllPolicyParameter The parameters of the policy, the values are dependent on the type of the policy.
//
// swagger:model ConfigurationsResponseScanAllPolicyParameter
type ConfigurationsResponseScanAllPolicyParameter struct {

	// The offset in seconds of UTC 0 o'clock, only valid when the policy type is "daily"
	DailyTime int64 `json:"daily_time,omitempty"`
}

// Validate validates this configurations response scan all policy parameter
func (m *ConfigurationsResponseScanAllPolicyParameter) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this configurations response scan all policy parameter based on context it is used
func (m *ConfigurationsResponseScanAllPolicyParameter) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConfigurationsResponseScanAllPolicyParameter) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConfigurationsResponseScanAllPolicyParameter) UnmarshalBinary(b []byte) error {
	var res ConfigurationsResponseScanAllPolicyParameter
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
